/*
 * Copyright (c) 2021, MediaTek Inc. All rights reserved.
 *
 * SPDX-License-Identifier: BSD-3-Clause
 */

#include <stddef.h>
#include <string.h>
#include <common/debug.h>
#include <lib/bakery_lock.h>
#include <lib/mmio.h>
#include <mt_lp_rm.h>
#include <mt_spm.h>
#include <mt_spm_cond.h>
#include <mt_spm_conservation.h>
#include <mt_spm_constraint.h>
#include <mt_spm_idle.h>
#include <mt_spm_internal.h>
#include <mt_spm_pmic_wrap.h>
#include <mt_spm_rc_internal.h>
#include <mt_spm_reg.h>
#include <mt_spm_resource_req.h>
#include <mt_spm_suspend.h>
#include <mtk_plat_common.h>
#include <plat_mtk_lpm.h>
#include <plat_pm.h>
#include <platform_def.h>
#include <sleep_def.h>
#include <assert.h>
#include <mcu.h>

#ifdef MT_SPM_USING_BAKERY_LOCK
DEFINE_BAKERY_LOCK(spm_lock);
#define plat_spm_lock_init() bakery_lock_init(&spm_lock)
#else
spinlock_t spm_lock;
#define plat_spm_lock_init()
#endif

/* CLK_SCP_CFG_0 */
#define CLK_SCP_CFG_0		(TOPCKGEN_BASE + 0x264)
#define SPM_CK_CONTROL_EN	0x7FF

struct mt_resource_constraint plat_constraint_bus26m = {
	.is_valid = spm_is_valid_rc_bus26m,
	.update = spm_update_rc_bus26m,
	.allow = spm_allow_rc_bus26m,
	.run = spm_run_rc_bus26m,
	.reset = spm_reset_rc_bus26m,
};

struct mt_resource_constraint plat_constraint_syspll = {
	.is_valid = spm_is_valid_rc_syspll,
	.update = spm_update_rc_syspll,
	.allow = spm_allow_rc_syspll,
	.run = spm_run_rc_syspll,
	.reset = spm_reset_rc_syspll,
};

struct mt_resource_constraint plat_constraint_dram = {
	.is_valid = spm_is_valid_rc_dram,
	.update = spm_update_rc_dram,
	.allow = spm_allow_rc_dram,
	.run = spm_run_rc_dram,
	.reset = spm_reset_rc_dram,
};

struct mt_resource_constraint plat_constraint_cpu = {
	.is_valid = spm_is_valid_rc_cpu_buck_ldo,
	.update = NULL,
	.allow = spm_allow_rc_cpu_buck_ldo,
	.run = spm_run_rc_cpu_buck_ldo,
	.reset = spm_reset_rc_cpu_buck_ldo,
};

struct mt_resource_constraint *plat_constraints[] = {
	&plat_constraint_bus26m,
	&plat_constraint_syspll,
	&plat_constraint_dram,
	&plat_constraint_cpu,
	NULL,
};

struct mt_resource_manager plat_mt8195_rm = {
	.update = mt_spm_cond_update,
	.consts = plat_constraints,
};

_Alignas(16) static const uint8_t spm_binary[] = {
	0xdd, 0x09, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	0x00, 0x00, 0x00, 0x00, 0x00, 0x1e, 0x00, 0x00, 0x32, 0x1e, 0x00,
	0x00, 0x6a, 0x1e, 0x00, 0x00, 0x6e, 0x1e, 0x00, 0x00, 0x68, 0x1e,
	0x00, 0x00, 0x62, 0x1e, 0x00, 0x00, 0x60, 0x1e, 0x00, 0x00, 0x5e,
	0x1e, 0x00, 0x00, 0x5c, 0x1e, 0x00, 0x00, 0x60, 0x1e, 0x00, 0x00,
	0x58, 0x1e, 0x00, 0x00, 0x56, 0x1e, 0x00, 0x00, 0x54, 0x1e, 0x00,
	0x00, 0x52, 0x1e, 0x00, 0x00, 0x50, 0x1e, 0x00, 0x00, 0x4e, 0x1e,
	0x00, 0x00, 0x4c, 0x1e, 0x00, 0x01, 0xf2, 0x1e, 0x00, 0x01, 0x14,
	0x1e, 0x00, 0x02, 0x4c, 0x1e, 0x00, 0x01, 0x26, 0x1e, 0x00, 0x07,
	0xea, 0x1e, 0x00, 0x01, 0x20, 0x1e, 0x00, 0x01, 0x1c, 0x1e, 0x00,
	0x01, 0x18, 0x1e, 0x00, 0x01, 0x14, 0x98, 0x0f, 0x0f, 0x00, 0x00,
	0x0e, 0x0d, 0x30, 0x00, 0xee, 0x0f, 0x00, 0x00, 0x01, 0x0d, 0x38,
	0x60, 0x11, 0x0f, 0x00, 0x00, 0x02, 0x0d, 0x38, 0xd8, 0x22, 0x1c,
	0x00, 0x18, 0x12, 0x04, 0x01, 0xe1, 0x23, 0x04, 0x1c, 0x62, 0x32,
	0x0c, 0x00, 0x03, 0x33, 0x1c, 0x80, 0x14, 0x40, 0x06, 0xf0, 0x04,
	0x01, 0x09, 0x00, 0x01, 0x22, 0x1d, 0x83, 0xf8, 0x40, 0x1c, 0x80,
	0x10, 0x60, 0x06, 0xd0, 0x01, 0x01, 0x09, 0x00, 0x01, 0x33, 0x1d,
	0x83, 0xf8, 0x60, 0x04, 0x15, 0x40, 0x01, 0x0d, 0x00, 0x01, 0x11,
	0x04, 0x18, 0x20, 0x10, 0x93, 0x03, 0x93, 0x04, 0x1f, 0x00, 0x12,
	0xbb, 0x93, 0x13, 0x1f, 0x00, 0x00, 0x04, 0x1e, 0x00, 0x00, 0x00,
	0x98, 0x11, 0x05, 0xc0, 0x00, 0x20, 0xa0, 0x3f, 0x05, 0x80, 0x00,
	0x00, 0x05, 0xa0, 0x00, 0x00, 0x05, 0xa0, 0x00, 0x00, 0x05, 0xa0,
	0x00, 0x00, 0x92, 0x02, 0xa7, 0xe1, 0xa7, 0xf2, 0x00, 0x03, 0x8c,
	0x01, 0xac, 0x82, 0xad, 0x03, 0xad, 0x84, 0xae, 0x05, 0xae, 0x86,
	0xa5, 0xe2, 0xac, 0x02, 0x00, 0x03, 0x8b, 0x01, 0xa8, 0x02, 0x08,
	0x00, 0x01, 0x22, 0xac, 0x02, 0xa5, 0xe1, 0xa5, 0xf2, 0x97, 0xee,
	0x05, 0xa0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x03, 0x8a, 0x01, 0x00,
	0x03, 0x8a, 0x48, 0xa8, 0x07, 0x0f, 0x0f, 0xff, 0x01, 0x0d, 0xff,
	0xff, 0x16, 0x0f, 0xf0, 0x00, 0x01, 0x8a, 0x71, 0x0f, 0x30, 0x00,
	0x07, 0x0d, 0x68, 0x4c, 0x77, 0xac, 0x71, 0xa8, 0x61, 0x45, 0x0b,
	0x28, 0x71, 0xa0, 0x2f, 0x8b, 0x61, 0xb6, 0x61, 0x80, 0x00, 0x00,
	0x00, 0x80, 0x01, 0xa0, 0x2f, 0x00, 0x08, 0x00, 0x06, 0x07, 0x00,
	0x65, 0x61, 0x80, 0x00, 0x00, 0x00, 0x80, 0x01, 0xf3, 0xc0, 0x0c,
	0x80, 0x00, 0x11, 0xbb, 0x11, 0x00, 0x00, 0x80, 0x01, 0x00, 0x08,
	0x00, 0x06, 0x0f, 0x30, 0x00, 0x07, 0x0d, 0x64, 0x80, 0x77, 0x07,
	0x00, 0x64, 0x61, 0xa8, 0x61, 0x0c, 0x00, 0xf0, 0x11, 0x1c, 0x9f,
	0xfa, 0x30, 0xa0, 0x3f, 0xa0, 0x3f, 0x80, 0x00, 0xa8, 0x21, 0xc9,
	0xa0, 0xa0, 0x2f, 0x20, 0x02, 0x44, 0x11, 0xac, 0x21, 0x04, 0x1e,
	0x68, 0x31, 0x0f, 0x30, 0x00, 0x06, 0x08, 0x69, 0x8c, 0x66, 0xc9,
	0x08, 0xa0, 0x2f, 0xac, 0x51, 0xac, 0x50, 0xa8, 0x21, 0x0d, 0x0f,
	0x00, 0x11, 0xb4, 0x21, 0xa8, 0x21, 0xc9, 0x08, 0xb4, 0x21, 0xa8,
	0x21, 0xc9, 0x20, 0xb4, 0x21, 0xa8, 0x21, 0xc9, 0x80, 0xb4, 0x21,
	0xa8, 0x21, 0xc9, 0x90, 0xb4, 0x21, 0xa8, 0x21, 0xa0, 0x2f, 0xc9,
	0x98, 0xb6, 0x21, 0x00, 0x03, 0x86, 0xc1, 0xa8, 0x01, 0x0c, 0x00,
	0x04, 0x11, 0xbc, 0x31, 0x40, 0x00, 0x20, 0x3f, 0x0f, 0x30, 0x00,
	0x01, 0x0d, 0x66, 0x44, 0x11, 0xa8, 0x06, 0xc9, 0x9d, 0xa0, 0x2f,
	0x20, 0x02, 0x33, 0x66, 0xb6, 0x06, 0x0f, 0x30, 0x00, 0x01, 0x0d,
	0x68, 0x50, 0x11, 0x0f, 0x10, 0x00, 0x07, 0xa8, 0x08, 0xc9, 0x87,
	0xc9, 0x0f, 0x00, 0x00, 0x10, 0x02, 0x06, 0xf1, 0xd0, 0x81, 0x00,
	0x01, 0x00, 0x88, 0xb5, 0x87, 0x00, 0x03, 0x8a, 0x06, 0x06, 0xf2,
	0xd4, 0x21, 0xac, 0x08, 0xa8, 0x56, 0x0c, 0x10, 0x00, 0x66, 0x0f,
	0x30, 0x00, 0x07, 0xbc, 0x46, 0xa8, 0x06, 0xc9, 0x15, 0xac, 0x06,
	0x00, 0x40, 0x00, 0x01, 0x0f, 0x30, 0x00, 0x06, 0x0d, 0x60, 0x74,
	0x66, 0x07, 0x00, 0x65, 0x12, 0xa8, 0x58, 0xbe, 0x78, 0x05, 0x80,
	0x00, 0x00, 0xa8, 0x58, 0x1c, 0x83, 0xfb, 0x00, 0xa0, 0x00, 0x07,
	0x00, 0x64, 0x12, 0x0f, 0x30, 0x00, 0x01, 0x0d, 0x66, 0x34, 0x11,
	0xa8, 0x06, 0x04, 0x89, 0xfc, 0x66, 0x1c, 0x83, 0xfa, 0xc0, 0xa0,
	0x2f, 0x08, 0x60, 0x74, 0x71, 0xac, 0x00, 0x80, 0x00, 0x92, 0x02,
	0xa7, 0xe1, 0x4c, 0x0b, 0x27, 0xf6, 0x00, 0x00, 0x14, 0x01, 0xf2,
	0x28, 0xf3, 0x40, 0xa5, 0xf6, 0xa5, 0xe1, 0x97, 0xee, 0x05, 0xa0,
	0x00, 0x00, 0x80, 0x00, 0x05, 0xa0, 0x00, 0x00, 0x05, 0xa0, 0x00,
	0x00, 0x05, 0xa0, 0x00, 0x00, 0x05, 0xa0, 0x00, 0x00, 0x05, 0xa0,
	0x00, 0x00, 0x0f, 0x30, 0x00, 0x01, 0x0f, 0x10, 0x00, 0x03, 0x08,
	0x6a, 0x08, 0x18, 0x0d, 0x3f, 0x00, 0x37, 0x14, 0xc0, 0x1a, 0x10,
	0x00, 0x10, 0x00, 0x06, 0x49, 0x80, 0xa0, 0x00, 0x44, 0x30, 0xac,
	0x71, 0x06, 0x40, 0x58, 0x28, 0xb4, 0xe2, 0x06, 0x40, 0x5c, 0x28,
	0xb4, 0xe2, 0x00, 0x00, 0x10, 0x06, 0x08, 0x3f, 0x80, 0x31, 0xf3,
	0x35, 0xb4, 0x87, 0xf3, 0x75, 0xb4, 0x87, 0xf3, 0xb5, 0xb4, 0x87,
	0xf3, 0xf5, 0xb4, 0x87, 0x07, 0x00, 0x44, 0x76, 0xb4, 0x87, 0x07,
	0x00, 0x45, 0x76, 0xb4, 0x87, 0x07, 0x00, 0x46, 0x76, 0xb4, 0x87,
	0x07, 0x00, 0x47, 0x76, 0xb4, 0x87, 0x07, 0x00, 0x48, 0x76, 0xb4,
	0x87, 0x07, 0x00, 0x49, 0x76, 0xb4, 0x87, 0x07, 0x00, 0x4a, 0x76,
	0xb4, 0x87, 0xa0, 0x2f, 0x07, 0x00, 0x51, 0x66, 0xac, 0x06, 0x80,
	0x00, 0xb9, 0xa4, 0x00, 0x00, 0x14, 0x01, 0xa8, 0x31, 0x20, 0x11,
	0xc0, 0x31, 0xac, 0x31, 0xa8, 0x31, 0x04, 0x89, 0xbd, 0x11, 0x04,
	0x89, 0x9c, 0x11, 0x40, 0x00, 0x2c, 0x31, 0xa8, 0x31, 0x04, 0x89,
	0xfe, 0x11, 0x1c, 0x83, 0xfa, 0x20, 0xa8, 0x31, 0x04, 0x89, 0xbc,
	0x11, 0xa0, 0x2f, 0x04, 0x89, 0x9d, 0x11, 0xac, 0x31, 0xf3, 0x68,
	0xf2, 0x90, 0xf3, 0x68, 0x1c, 0x83, 0xfe, 0xc0, 0xa0, 0x3f, 0x00,
	0x00, 0x10, 0x01, 0x0f, 0x01, 0x97, 0x06, 0x07, 0x00, 0x60, 0x01,
	0x0f, 0x01, 0xff, 0x07, 0x4c, 0x1b, 0x72, 0x68, 0xa0, 0x2f, 0x07,
	0x00, 0x66, 0x71, 0xf2, 0x28, 0x92, 0x01, 0x0f, 0x30, 0x00, 0x08,
	0x0d, 0x6b, 0x00, 0x88, 0x4c, 0x22, 0xa7, 0xff, 0x0f, 0xfd, 0xff,
	0x01, 0xa8, 0x74, 0x0d, 0xff, 0xeb, 0x11, 0x8a, 0x41, 0x98, 0x84,
	0x06, 0xf2, 0x10, 0x18, 0x00, 0x02, 0x55, 0x01, 0xb4, 0xf5, 0x00,
	0x01, 0x00, 0x05, 0xb4, 0xf4, 0xb4, 0xf1, 0x00, 0x04, 0xaa, 0x01,
	0xb4, 0xf5, 0xb4, 0xf0, 0xb4, 0xf1, 0x0f, 0x07, 0xff, 0x03, 0x0d,
	0xff, 0xfc, 0x31, 0xb4, 0xf0, 0x06, 0xff, 0xd8, 0x08, 0x06, 0xf8,
	0x00, 0x18, 0x06, 0x4b, 0x0c, 0x18, 0x00, 0x03, 0x88, 0x83, 0x00,
	0x03, 0x87, 0xc2, 0x00, 0x03, 0x8a, 0x87, 0x4f, 0xf9, 0xac, 0x21,
	0x00, 0x03, 0x88, 0x46, 0xac, 0x10, 0x00, 0x00, 0x14, 0x01, 0xac,
	0x60, 0x4c, 0x0b, 0x2c, 0x50, 0x07, 0x00, 0x63, 0x01, 0x07, 0x00,
	0x62, 0x01, 0x17, 0x1f, 0xff, 0xb7, 0xf2, 0x28, 0x00, 0x00, 0x80,
	0x02, 0x00, 0x00, 0x80, 0x01, 0x4f, 0xfb, 0x72, 0x91, 0x00, 0x00,
	0x0f, 0x17, 0x07, 0x00, 0x65, 0x61, 0x06, 0x4b, 0x00, 0x68, 0xf2,
	0x68, 0x06, 0x4b, 0x04, 0x68, 0x07, 0x00, 0x64, 0x61, 0x06, 0x4b,
	0x20, 0x68, 0x07, 0x00, 0x71, 0x61, 0x06, 0x7b, 0x28, 0x78, 0xa5,
	0xff, 0xa0, 0x2f, 0x97, 0xfe, 0x80, 0x00, 0x80, 0x00, 0x92, 0x0d,
	0xa7, 0xa4, 0x04, 0x15, 0x40, 0x54, 0xa7, 0x93, 0xa7, 0xb5, 0x04,
	0x15, 0x40, 0x63, 0x04, 0x15, 0x40, 0x75, 0xa7, 0x54, 0x0f, 0x30,
	0x00, 0x04, 0x0d, 0x6d, 0x00, 0x44, 0xa7, 0x71, 0xa7, 0xd7, 0xa7,
	0xf9, 0xa7, 0x45, 0xa7, 0x82, 0xa7, 0xc6, 0xa7, 0xe8, 0xa7, 0x3f,
	0xa7, 0x63, 0xa8, 0x36, 0xc9, 0x95, 0x0f, 0x02, 0x00, 0x01, 0x06,
	0xfd, 0x00, 0x64, 0xa8, 0x36, 0xc9, 0x0d, 0x0d, 0x00, 0x14, 0x11,
	0x06, 0xf1, 0x00, 0x64, 0xa8, 0x36, 0x8b, 0x61, 0x0f, 0xde, 0xad,
	0x07, 0x0d, 0xde, 0xad, 0x76, 0x06, 0xf9, 0xec, 0x14, 0x0f, 0x50,
	0x00, 0x07, 0x06, 0xf7, 0x14, 0x64, 0x17, 0x1f, 0xff, 0x0c, 0x0d,
	0x60, 0x00, 0x79, 0x0f, 0x10, 0x00, 0x05, 0x0d, 0x3a, 0x00, 0x51,
	0xb4, 0xb9, 0x00, 0x00, 0xb9, 0x06, 0xb5, 0x31, 0x00, 0x00, 0x14,
	0x01, 0xb7, 0xb5, 0x00, 0x38, 0x20, 0xe7, 0xb5, 0x36, 0x00, 0x08,
	0x00, 0x06, 0xb4, 0xb1, 0xb4, 0xb7, 0xac, 0x36, 0xa5, 0x45, 0xa5,
	0x54, 0xa5, 0x63, 0x04, 0x18, 0x20, 0x57, 0x04, 0x18, 0x20, 0x45,
	0x04, 0x18, 0x20, 0x36, 0xa5, 0x3f, 0xa5, 0x71, 0xa5, 0x82, 0xa5,
	0xc6, 0xa5, 0xd7, 0xa5, 0xe8, 0xa5, 0xf9, 0xa5, 0xb5, 0xa5, 0xa4,
	0xa5, 0x93, 0x97, 0x3e, 0x05, 0xa0, 0x00, 0x00, 0x80, 0x00, 0x92,
	0x03, 0xa7, 0xd1, 0x0f, 0x30, 0x00, 0x01, 0x0d, 0x6a, 0x24, 0x11,
	0xa7, 0xf7, 0xa7, 0xe6, 0xb3, 0x86, 0xb6, 0x00, 0xbb, 0x66, 0x0f,
	0x30, 0x00, 0x07, 0x0f, 0xde, 0xad, 0x01, 0x08, 0x66, 0x34, 0x76,
	0x0d, 0xde, 0xad, 0x11, 0xac, 0x51, 0x08, 0x6d, 0x30, 0x71, 0x00,
	0x00, 0x0c, 0x86, 0xac, 0x06, 0xa5, 0xd1, 0xa5, 0xe6, 0xa5, 0xf7,
	0x4b, 0xef, 0x20, 0x00, 0x05, 0xa0, 0x00, 0x00, 0x08, 0x66, 0x34,
	0x71, 0x06, 0xf2, 0x18, 0x61, 0xa8, 0x06, 0x04, 0x89, 0x9b, 0x66,
	0xa1, 0x6d, 0xac, 0x06, 0x80, 0x00, 0x92, 0x01, 0x00, 0x03, 0x8a,
	0x08, 0xa7, 0xff, 0xa8, 0x71, 0x0c, 0x20, 0x00, 0x11, 0xba, 0x91,
	0x0f, 0x30, 0x00, 0x01, 0x08, 0x60, 0x34, 0x11, 0x00, 0xf0, 0x00,
	0x06, 0x40, 0x00, 0x2c, 0x06, 0x00, 0x00, 0x80, 0x02, 0x00, 0x00,
	0x20, 0x01, 0x00, 0x01, 0x00, 0x06, 0x0f, 0x00, 0x40, 0x05, 0x07,
	0x00, 0x65, 0x12, 0x07, 0x00, 0x64, 0x62, 0x07, 0x00, 0x64, 0x52,
	0x49, 0x82, 0x20, 0x00, 0x17, 0x1f, 0xfe, 0xd0, 0x00, 0x00, 0x30,
	0xc3, 0x0f, 0x30, 0x00, 0x07, 0x0d, 0x61, 0x4c, 0x77, 0x07, 0x00,
	0x65, 0x52, 0x06, 0xc4, 0xf0, 0x17, 0xb4, 0xe1, 0x06, 0x4a, 0xf0,
	0x17, 0x06, 0xf3, 0xec, 0x17, 0x06, 0xfb, 0xd4, 0x07, 0x06, 0x7a,
	0x74, 0x07, 0xa8, 0x61, 0xc9, 0x50, 0xac, 0x61, 0xa8, 0x61, 0xac,
	0x71, 0xa5, 0xff, 0xa0, 0x2f, 0x97, 0xfe, 0x80, 0x00, 0x49, 0x00,
	0xf0, 0x38, 0xf0, 0x04, 0xa7, 0xff, 0xa8, 0x71, 0xc9, 0x00, 0x00,
	0x00, 0x05, 0xe3, 0xb4, 0x71, 0xa8, 0x71, 0xc9, 0x88, 0x01, 0xff,
	0x00, 0xf7, 0x17, 0x1f, 0xfe, 0xa5, 0xb4, 0x71, 0xa8, 0x71, 0x8a,
	0x17, 0xb6, 0x77, 0xa5, 0xff, 0xa0, 0x2f, 0x97, 0xfe, 0x80, 0x00,
	0x80, 0x00, 0x49, 0x00, 0xf0, 0x37, 0xa7, 0xff, 0xa8, 0x61, 0x80,
	0x40, 0xb9, 0xd1, 0xa5, 0xff, 0x14, 0xc0, 0x12, 0x08, 0x80, 0x00,
	0x4c, 0x20, 0xa0, 0x00, 0xa8, 0x66, 0x04, 0x88, 0x01, 0x66, 0x86,
	0x11, 0xac, 0x66, 0x93, 0x04, 0x17, 0x1f, 0xfe, 0x88, 0x00, 0x00,
	0x09, 0xc3, 0xa8, 0x61, 0x0d, 0x00, 0x06, 0x11, 0xb4, 0x61, 0xa8,
	0x61, 0xc9, 0x80, 0xb6, 0x61, 0xa5, 0xff, 0xa0, 0x2f, 0x97, 0xfe,
	0x40, 0x00, 0x20, 0x00, 0xa0, 0x2f, 0x97, 0xfe, 0x80, 0x00, 0x80,
	0x00, 0x49, 0x00, 0xf0, 0x37, 0xa7, 0xff, 0xa8, 0x61, 0x80, 0x40,
	0x14, 0x80, 0x4e, 0x20, 0xa5, 0xff, 0x14, 0xc0, 0x10, 0x08, 0x80,
	0x00, 0x98, 0x41, 0xa8, 0x66, 0x04, 0x88, 0x01, 0x66, 0x86, 0x11,
	0xac, 0x66, 0x00, 0x00, 0x80, 0x01, 0xf3, 0xc0, 0x0c, 0x00, 0x30,
	0x11, 0x14, 0x84, 0x0c, 0x20, 0x00, 0x00, 0x09, 0xc3, 0x4d, 0xa1,
	0xa0, 0x00, 0x17, 0x1f, 0xfe, 0x58, 0x49, 0x82, 0x20, 0x00, 0xa8,
	0x61, 0x0d, 0x00, 0x06, 0x11, 0xb4, 0x61, 0xa8, 0x61, 0xc9, 0x80,
	0xb6, 0x61, 0xa5, 0xff, 0xa0, 0x2f, 0x97, 0xfe, 0x40, 0x00, 0x20,
	0x00, 0xa0, 0x2f, 0x97, 0xfe, 0x80, 0x00, 0x80, 0x00, 0x14, 0x80,
	0x6d, 0x00, 0x00, 0x00, 0x14, 0x07, 0x0f, 0x30, 0x00, 0x07, 0x0d,
	0x69, 0x80, 0x77, 0xa8, 0x61, 0x20, 0x11, 0xc0, 0x61, 0xac, 0x61,
	0xa8, 0x61, 0x04, 0x89, 0xbd, 0x11, 0x04, 0x89, 0x9c, 0x11, 0xac,
	0x61, 0x06, 0x4d, 0x84, 0x17, 0x0c, 0x00, 0x02, 0x11, 0xbb, 0x81,
	0x08, 0xfd, 0x84, 0x71, 0x0f, 0x30, 0x00, 0x08, 0x0d, 0x68, 0x50,
	0x88, 0xa0, 0x00, 0xa8, 0x66, 0x04, 0x89, 0xfe, 0x66, 0xbc, 0x76,
	0xa8, 0x76, 0x04, 0x89, 0x9c, 0x62, 0x49, 0xc3, 0x20, 0x00, 0xb6,
	0x52, 0xa8, 0x06, 0x0c, 0x00, 0x02, 0x66, 0x1c, 0x83, 0xe6, 0xc0,
	0xa0, 0x00, 0xa8, 0x61, 0x04, 0x89, 0xbc, 0x11, 0x40, 0x00, 0x20,
	0x2f, 0x04, 0x89, 0x9d, 0x11, 0xb6, 0x61, 0xf3, 0x46, 0xf2, 0xae,
	0xa8, 0x21, 0x8a, 0x41, 0x1d, 0x7f, 0xfe, 0x51, 0xa0, 0x2f, 0xf3,
	0x46, 0x07, 0x00, 0x62, 0x07, 0x49, 0xac, 0x70, 0x46, 0x0f, 0x30,
	0x00, 0x02, 0x0d, 0x67, 0x04, 0x22, 0x00, 0x30, 0x00, 0x07, 0xa8,
	0x11, 0x8a, 0x71, 0x15, 0x83, 0xfc, 0x20, 0x0f, 0x30, 0x00, 0x01,
	0x08, 0x67, 0x00, 0x12, 0x98, 0x24, 0x4c, 0x12, 0xac, 0x13, 0x0d,
	0x67, 0x04, 0x13, 0x16, 0x1f, 0xff, 0xab, 0x0f, 0x10, 0x00, 0x07,
	0x80, 0x00, 0x92, 0x01, 0x0f, 0x30, 0x00, 0x01, 0x0d, 0x60, 0xac,
	0x11, 0xbb, 0x93, 0xa7, 0xff, 0x49, 0x89, 0xf0, 0x08, 0x99, 0x04,
	0x4c, 0x82, 0xa8, 0x21, 0xc9, 0x18, 0x0f, 0x08, 0x00, 0x07, 0xac,
	0x21, 0x17, 0x1f, 0xff, 0x96, 0x00, 0x00, 0x92, 0x46, 0x06, 0x47,
	0xa4, 0x13, 0xc9, 0x68, 0x06, 0x77, 0xa4, 0x13, 0xa5, 0xff, 0xa0,
	0x2f, 0x97, 0xfe, 0x40, 0x00, 0x20, 0x00, 0x49, 0x89, 0xf0, 0x05,
	0x4c, 0x82, 0x70, 0x08, 0xa8, 0x21, 0x64, 0xcc, 0x20, 0x00, 0x0f,
	0x04, 0x00, 0x07, 0xac, 0x21, 0x17, 0x1f, 0xff, 0x7e, 0x00, 0x00,
	0x92, 0x46, 0x06, 0x47, 0xa4, 0x13, 0xc9, 0x70, 0x06, 0x77, 0xa4,
	0x13, 0xa5, 0xff, 0xa0, 0x2f, 0x97, 0xfe, 0x80, 0x00, 0x80, 0x00,
	0x92, 0x01, 0x0f, 0x30, 0x00, 0x01, 0x0d, 0x61, 0x48, 0x11, 0xa7,
	0xff, 0xa8, 0x01, 0x80, 0x40, 0xb8, 0x61, 0xa5, 0xff, 0xa0, 0x2f,
	0x97, 0xfe, 0x40, 0x00, 0x20, 0x00, 0x00, 0x00, 0x80, 0x09, 0x9a,
	0x01, 0x0f, 0x30, 0x00, 0x06, 0x0d, 0x6a, 0x24, 0x66, 0x07, 0x00,
	0x61, 0x19, 0xa8, 0x56, 0xb9, 0x66, 0x00, 0x00, 0x10, 0x07, 0x07,
	0x00, 0x62, 0x19, 0x0f, 0x30, 0x00, 0x01, 0x0d, 0x68, 0x50, 0x11,
	0xa8, 0x06, 0xc9, 0x3d, 0x00, 0x01, 0x00, 0x48, 0x06, 0xf1, 0xdc,
	0x61, 0x06, 0xf2, 0xd4, 0x71, 0xac, 0x08, 0xa5, 0xff, 0xa0, 0x2f,
	0x97, 0xfe, 0x80, 0x00, 0x00, 0x03, 0x8a, 0x0a, 0x06, 0x40, 0x00,
	0x1a, 0x0c, 0x00, 0x40, 0x11, 0x14, 0x81, 0xc0, 0x20, 0x0f, 0x30,
	0x00, 0x01, 0x06, 0x40, 0x00, 0x1a, 0x0c, 0x20, 0x00, 0x11, 0xbe,
	0x41, 0x17, 0x1f, 0xfc, 0xd3, 0x98, 0x13, 0x06, 0x40, 0x00, 0x1a,
	0x0c, 0x20, 0x00, 0x11, 0xbe, 0xa1, 0x06, 0x40, 0x00, 0x1a, 0x0c,
	0x08, 0x00, 0x11, 0xbe, 0x51, 0x17, 0x1f, 0xff, 0x80, 0x49, 0x81,
	0xa0, 0x00, 0x06, 0x40, 0x00, 0x1a, 0x0c, 0x20, 0x00, 0x11, 0xbc,
	0xa1, 0x06, 0x40, 0x00, 0x1a, 0x0c, 0x40, 0x00, 0x11, 0x15, 0x80,
	0xee, 0x20, 0x0f, 0x30, 0x00, 0x01, 0xa0, 0x00, 0x06, 0x40, 0x00,
	0x1a, 0x0c, 0x20, 0x00, 0x11, 0xb9, 0x61, 0x00, 0x03, 0x86, 0xc1,
	0xa8, 0x01, 0x0c, 0x04, 0x00, 0x11, 0xbb, 0x01, 0x93, 0x05, 0x00,
	0x00, 0x10, 0x44, 0x17, 0x1f, 0xff, 0x46, 0x4c, 0x29, 0xa0, 0x00,
	0x0f, 0x30, 0x00, 0x01, 0x0d, 0x68, 0x50, 0x11, 0xa8, 0x06, 0x04,
	0x89, 0x91, 0x66, 0xb6, 0x06, 0x0f, 0x30, 0x00, 0x02, 0x0d, 0x68,
	0x4c, 0x22, 0x98, 0x13, 0xa8, 0x11, 0x64, 0x84, 0x20, 0x00, 0x00,
	0x00, 0x10, 0x04, 0x17, 0x1f, 0xfc, 0x72, 0x06, 0xf1, 0xe0, 0x12,
	0x06, 0x40, 0x00, 0x1a, 0x04, 0x89, 0xbc, 0x11, 0x00, 0x00, 0x0f,
	0xf5, 0x17, 0x1f, 0xfc, 0x2a, 0x06, 0x70, 0x00, 0x1a, 0x06, 0xf3,
	0x04, 0x32, 0xf3, 0x83, 0x04, 0x89, 0xb6, 0x11, 0xf2, 0x83, 0xac,
	0x15, 0x06, 0x40, 0x00, 0x1a, 0x0c, 0x20, 0x00, 0x11, 0xb8, 0x51,
	0xa5, 0xff, 0xa0, 0x2f, 0x97, 0xfe, 0x80, 0x00, 0x00, 0x00, 0x80,
	0x02, 0x00, 0x20, 0x00, 0x01, 0x00, 0x02, 0x00, 0x08, 0x07, 0x00,
	0x64, 0x12, 0x93, 0x04, 0x17, 0x1f, 0xfd, 0x0d, 0x99, 0x43, 0x0f,
	0x30, 0x00, 0x07, 0x0d, 0x61, 0x30, 0x77, 0x07, 0x00, 0x64, 0x82,
	0x4e, 0x7b, 0x28, 0x61, 0x00, 0x03, 0x87, 0xc7, 0x98, 0x18, 0xac,
	0x61, 0x07, 0x00, 0x43, 0x19, 0x45, 0x30, 0xa5, 0xff, 0xc9, 0x20,
	0x0f, 0x00, 0x10, 0x07, 0xf2, 0xc1, 0x00, 0x04, 0x84, 0x01, 0x07,
	0x00, 0x61, 0x89, 0x07, 0x00, 0x61, 0x79, 0x07, 0x00, 0x65, 0x12,
	0x07, 0x00, 0x43, 0x19, 0x8a, 0x16, 0x0d, 0x00, 0x30, 0x61, 0xf2,
	0xc1, 0x4b, 0xff, 0x20, 0x3f, 0x08, 0x67, 0x08, 0x1d, 0x00, 0x00,
	0x05, 0xb1, 0x00, 0x00, 0x10, 0x44, 0x06, 0x70, 0x00, 0x1d, 0x17,
	0x1f, 0xfe, 0xda, 0x4c, 0x61, 0xf0, 0x05, 0x93, 0x05, 0x00, 0x00,
	0x10, 0x44, 0x17, 0x1f, 0xfe, 0xd3, 0x98, 0xd3, 0x93, 0x05, 0x00,
	0x00, 0x10, 0x44, 0x17, 0x1f, 0xfe, 0xcd, 0x98, 0xb3, 0x00, 0x00,
	0x05, 0xfc, 0x93, 0x05, 0x00, 0x00, 0x10, 0x44, 0x17, 0x1f, 0xfe,
	0xc5, 0x98, 0x93, 0x06, 0x70, 0x00, 0xcd, 0x93, 0x05, 0x00, 0x00,
	0x10, 0x44, 0x17, 0x1f, 0xfe, 0xbd, 0x98, 0xc3, 0x93, 0x05, 0x00,
	0x00, 0x10, 0x44, 0x17, 0x1f, 0xfe, 0xb7, 0x98, 0xd3, 0x93, 0x05,
	0x00, 0x00, 0x10, 0x44, 0x17, 0x1f, 0xfe, 0xb1, 0x98, 0x73, 0x00,
	0x00, 0x08, 0x3c, 0x93, 0x05, 0x00, 0x00, 0x10, 0x44, 0x17, 0x1f,
	0xfe, 0xa9, 0x98, 0x93, 0x06, 0xf1, 0x48, 0xcd, 0x06, 0x40, 0x00,
	0x1d, 0x04, 0x89, 0x95, 0x11, 0x16, 0x1f, 0xff, 0x4c, 0x06, 0x70,
	0x00, 0x1d, 0x08, 0x64, 0x9c, 0x17, 0x4c, 0x08, 0xf0, 0x04, 0x4c,
	0x44, 0x20, 0x00, 0x06, 0xf3, 0xb4, 0x17, 0x17, 0x1f, 0xfc, 0x98,
	0x00, 0x00, 0x04, 0xe3, 0x07, 0x00, 0x61, 0x89, 0xa8, 0x61, 0xc9,
	0x78, 0x16, 0x1f, 0xff, 0x14, 0xac, 0x61, 0x80, 0x00, 0x92, 0x01,
	0x00, 0x03, 0x8a, 0x09, 0xa7, 0xff, 0x06, 0x40, 0x00, 0x19, 0x0c,
	0x20, 0x00, 0x11, 0x14, 0x81, 0xa8, 0x20, 0x00, 0x03, 0x88, 0x81,
	0x06, 0x40, 0x00, 0x19, 0x0c, 0x20, 0x00, 0x11, 0xb9, 0x61, 0x00,
	0x03, 0x86, 0xc1, 0xa8, 0x01, 0x0c, 0x04, 0x00, 0x11, 0xbb, 0x01,
	0x93, 0x05, 0x00, 0x00, 0x10, 0x44, 0x17, 0x1f, 0xfe, 0x6e, 0x4c,
	0x21, 0xa0, 0x00, 0x0f, 0x30, 0x00, 0x01, 0x0d, 0x68, 0x50, 0x11,
	0xa8, 0x06, 0x04, 0x89, 0x92, 0x66, 0xb6, 0x06, 0x06, 0x40, 0x00,
	0x19, 0x0c, 0x20, 0x00, 0x11, 0xbc, 0xa1, 0x06, 0x40, 0x00, 0x19,
	0x0c, 0x40, 0x00, 0x11, 0x15, 0x80, 0xba, 0x20, 0x0f, 0x30, 0x00,
	0x01, 0xa0, 0x00, 0x49, 0x82, 0x20, 0x00, 0x17, 0x1f, 0xfc, 0x56,
	0x00, 0x00, 0x10, 0x43, 0x06, 0x40, 0x00, 0x19, 0x0c, 0x20, 0x00,
	0x11, 0xbe, 0xa1, 0x06, 0x40, 0x00, 0x19, 0x0c, 0x08, 0x00, 0x11,
	0xbe, 0x51, 0x17, 0x1f, 0xfe, 0x5e, 0x4c, 0x09, 0xa0, 0x00, 0x06,
	0x40, 0x00, 0x19, 0x0c, 0x20, 0x00, 0x11, 0xbe, 0x41, 0x17, 0x1f,
	0xfb, 0x9b, 0x93, 0x03, 0x06, 0x40, 0x00, 0x19, 0x0c, 0x00, 0x40,
	0x11, 0xbb, 0x41, 0x00, 0x00, 0x80, 0x01, 0x4c, 0x43, 0x70, 0x04,
	0x0f, 0x30, 0x00, 0x07, 0x08, 0x64, 0x9c, 0x77, 0xf2, 0xa8, 0x06,
	0xf3, 0xb4, 0x07, 0x17, 0x1f, 0xfc, 0x2c, 0x00, 0x00, 0x04, 0xe3,
	0xa8, 0x61, 0x04, 0x89, 0x90, 0x11, 0xac, 0x61, 0x00, 0x00, 0x80,
	0x01, 0x4d, 0x03, 0x70, 0x03, 0x0f, 0x30, 0x00, 0x04, 0x0d, 0x68,
	0x4c, 0x44, 0x4f, 0xf9, 0x72, 0xa8, 0xa8, 0x31, 0x64, 0x80, 0x20,
	0x00, 0x17, 0x1f, 0xfb, 0x55, 0xac, 0x31, 0x06, 0x40, 0x00, 0x19,
	0x04, 0x89, 0x9c, 0x11, 0x17, 0x1f, 0xfb, 0x10, 0x06, 0xff, 0xf0,
	0x19, 0x06, 0xc1, 0xe0, 0x14, 0x8c, 0x12, 0x0c, 0x58, 0x00, 0x21,
	0x0d, 0x00, 0x06, 0x11, 0xac, 0x31, 0xa5, 0xff, 0xa0, 0x2f, 0x97,
	0xfe, 0x80, 0x00, 0x08, 0x67, 0x08, 0x1a, 0x00, 0x00, 0x05, 0xbd,
	0x00, 0x00, 0x05, 0xfc, 0x06, 0x70, 0x00, 0xda, 0x93, 0x05, 0x00,
	0x00, 0x10, 0x44, 0x17, 0x1f, 0xfd, 0xf1, 0x98, 0x83, 0x06, 0x70,
	0x00, 0xca, 0x93, 0x05, 0x00, 0x00, 0x10, 0x44, 0x17, 0x1f, 0xfd,
	0xe9, 0x98, 0x83, 0x06, 0x70, 0x00, 0xda, 0x49, 0x82, 0x70, 0x05,
	0x17, 0x1f, 0xfb, 0xe6, 0x00, 0x00, 0x10, 0x43, 0x00, 0x00, 0x10,
	0x44, 0x17, 0x1f, 0xfd, 0xdc, 0x4c, 0x51, 0xa0, 0x00, 0x93, 0x05,
	0x00, 0x00, 0x10, 0x44, 0x17, 0x1f, 0xfd, 0xd5, 0x98, 0xf3, 0x93,
	0x05, 0x00, 0x00, 0x10, 0x44, 0x17, 0x1f, 0xfd, 0xcf, 0x98, 0xe3,
	0x06, 0x70, 0x00, 0xca, 0x93, 0x05, 0x00, 0x00, 0x10, 0x44, 0x17,
	0x1f, 0xfd, 0xc7, 0x98, 0x63, 0x93, 0x05, 0x00, 0x00, 0x10, 0x44,
	0x17, 0x1f, 0xfd, 0xc1, 0x98, 0xf3, 0x00, 0x00, 0x08, 0x3d, 0x93,
	0x05, 0x00, 0x00, 0x10, 0x44, 0x17, 0x1f, 0xfd, 0xb9, 0x98, 0xe3,
	0x06, 0xf1, 0x48, 0xda, 0x06, 0x40, 0x00, 0x1a, 0x04, 0x89, 0x96,
	0x11, 0x16, 0x1f, 0xff, 0x62, 0x06, 0x70, 0x00, 0x1a, 0x00, 0x00,
	0x80, 0x07, 0x0f, 0x00, 0x10, 0x08, 0x17, 0x1f, 0xfb, 0xac, 0x49,
	0x82, 0x28, 0x03, 0x40, 0x00, 0x72, 0xbe, 0x17, 0x1f, 0xfb, 0xa6,
	0x00, 0x00, 0x10, 0x43, 0x00, 0x02, 0x00, 0x05, 0x98, 0x11, 0x07,
	0x00, 0x65, 0x57, 0x4e, 0x78, 0xf2, 0x86, 0xf3, 0xee, 0x8a, 0x61,
	0xc9, 0x20, 0x0f, 0x30, 0x00, 0x06, 0x0d, 0x61, 0x30, 0x66, 0xf2,
	0xc6, 0x06, 0xc5, 0x08, 0x16, 0x00, 0x03, 0x8a, 0x88, 0x00, 0x03,
	0x87, 0xc2, 0xac, 0x71, 0xa8, 0x71, 0xa8, 0x18, 0x89, 0x81, 0x00,
	0x03, 0x88, 0x48, 0x00, 0x20, 0x00, 0x02, 0xac, 0x71, 0xa8, 0x53,
	0xa8, 0x71, 0x88, 0x31, 0xac, 0x51, 0x16, 0x1f, 0xff, 0x00, 0x07,
	0x00, 0x65, 0x27, 0x49, 0x00, 0xf0, 0x37, 0x49, 0x82, 0x70, 0x43,
	0xa7, 0xff, 0xa8, 0x61, 0xc9, 0x10, 0x17, 0x1f, 0xfb, 0x75, 0xb4,
	0x61, 0xa8, 0x61, 0x64, 0x8c, 0x20, 0x00, 0x17, 0x1f, 0xfb, 0x6f,
	0xb4, 0x61, 0x17, 0x1f, 0xfb, 0x6c, 0x00, 0x00, 0xc3, 0x03, 0xa8,
	0x61, 0xc9, 0xa0, 0x00, 0x00, 0x09, 0xc3, 0xb4, 0x61, 0xa8, 0x61,
	0xc9, 0x88, 0xb4, 0x61, 0xa8, 0x61, 0xc9, 0x00, 0xb4, 0x61, 0xa8,
	0x61, 0xc9, 0x48, 0x17, 0x1f, 0xfb, 0x5b, 0xb4, 0x61, 0xa8, 0x61,
	0xc9, 0x30, 0xb4, 0x61, 0xa8, 0x61, 0xc9, 0xa8, 0xb6, 0x61, 0xa5,
	0xff, 0xa0, 0x2f, 0x97, 0xfe, 0x80, 0x00, 0x49, 0x00, 0xf0, 0x37,
	0xf0, 0x04, 0xa7, 0xff, 0xa8, 0x61, 0xc9, 0x28, 0x00, 0x00, 0x05,
	0xe3, 0xb4, 0x61, 0xa8, 0x61, 0xc9, 0xb0, 0x17, 0x1f, 0xfb, 0x43,
	0xb4, 0x61, 0xa8, 0x61, 0x64, 0xe4, 0x20, 0x00, 0x17, 0x1f, 0xfb,
	0x3d, 0xb4, 0x61, 0xa8, 0x61, 0xc9, 0x08, 0xb4, 0x61, 0xa8, 0x61,
	0xc9, 0x20, 0xb4, 0x61, 0xa8, 0x61, 0xc9, 0x80, 0xb4, 0x61, 0xa8,
	0x61, 0xc9, 0x90, 0xb4, 0x61, 0xa8, 0x61, 0xc9, 0x98, 0xb6, 0x61,
	0xa5, 0xff, 0xa0, 0x2f, 0x97, 0xfe, 0x80, 0x00, 0x80, 0x00, 0x49,
	0x00, 0xf0, 0x37, 0x49, 0x82, 0x70, 0x43, 0xa7, 0xff, 0xa8, 0x61,
	0xc9, 0x10, 0x17, 0x1f, 0xfb, 0x1f, 0xb4, 0x61, 0xa8, 0x61, 0x64,
	0x8c, 0x20, 0x00, 0x17, 0x1f, 0xfb, 0x19, 0xb4, 0x61, 0xa8, 0x61,
	0xc9, 0xa0, 0xb4, 0x61, 0xa8, 0x61, 0xc9, 0x88, 0xb4, 0x61, 0xa8,
	0x61, 0xc9, 0x00, 0xb4, 0x61, 0xa8, 0x61, 0xc9, 0xc0, 0x17, 0x1f,
	0xfb, 0x0b, 0xb4, 0x61, 0xa8, 0x61, 0x64, 0xe4, 0x20, 0x00, 0x17,
	0x1f, 0xfb, 0x05, 0xb4, 0x61, 0xa8, 0x61, 0x64, 0xe8, 0x20, 0x00,
	0x17, 0x1f, 0xfa, 0xff, 0xb4, 0x61, 0xa8, 0x61, 0xc9, 0xd8, 0xb6,
	0x61, 0xa5, 0xff, 0x16, 0x1f, 0xfa, 0xf8, 0x97, 0xfe, 0x80, 0x00,
	0x92, 0x01, 0x00, 0x03, 0x8a, 0x01, 0xa7, 0xff, 0xa8, 0x01, 0x04,
	0x89, 0xf3, 0x11, 0x15, 0x80, 0x62, 0x20, 0xa5, 0xff, 0x14, 0x80,
	0x10, 0x61, 0x0f, 0x80, 0x00, 0x01, 0x1c, 0x00, 0x04, 0x31, 0x1f,
	0x1f, 0xfa, 0x04, 0x0f, 0x80, 0x00, 0x07, 0x93, 0x31, 0x15, 0x00,
	0x05, 0x37, 0x00, 0x00, 0x80, 0x06, 0x98, 0x11, 0x0f, 0x01, 0x00,
	0x07, 0x07, 0x00, 0x70, 0x16, 0x07, 0x00, 0x64, 0x76, 0x07, 0x00,
	0x4c, 0x16, 0x04, 0x89, 0xf0, 0x11, 0x1c, 0x83, 0xf8, 0x20, 0x07,
	0x00, 0x65, 0x76, 0x15, 0x80, 0x0c, 0x68, 0xa5, 0xff, 0xa0, 0x2f,
	0x97, 0xfe, 0x80, 0x00, 0x15, 0x80, 0x0c, 0x64, 0xa5, 0xff, 0xa0,
	0x2f, 0x97, 0xfe, 0x80, 0x00, 0xa5, 0xff, 0x16, 0x1f, 0xf9, 0xd7,
	0x97, 0xfe, 0xa0, 0x2f, 0x97, 0xfe, 0x80, 0x00, 0x80, 0x00, 0x92,
	0x04, 0x0f, 0x30, 0x00, 0x01, 0x0d, 0x61, 0x9c, 0x11, 0xa7, 0xcf,
	0xa8, 0x0c, 0x06, 0x42, 0xfc, 0x31, 0x1c, 0x00, 0x03, 0xc3, 0xbe,
	0xbc, 0x0f, 0x30, 0x00, 0x01, 0x08, 0x64, 0x98, 0x11, 0xac, 0x00,
	0xac, 0x03, 0xa5, 0xcf, 0xa0, 0x2f, 0x97, 0xce, 0x80, 0x00, 0x1f,
	0x1f, 0xf9, 0xc2, 0x0f, 0x30, 0x00, 0x08, 0x0d, 0x64, 0xe8, 0x88,
	0x93, 0x87, 0x4c, 0xf9, 0x28, 0x71, 0x06, 0xcf, 0x88, 0x67, 0x20,
	0x21, 0x20, 0x66, 0x81, 0x00, 0xac, 0x66, 0xa7, 0xf6, 0x06, 0x4d,
	0x8c, 0x67, 0x20, 0x21, 0x54, 0x66, 0x13, 0xa0, 0x10, 0x60, 0x04,
	0x01, 0xe6, 0x26, 0x00, 0x02, 0x00, 0x02, 0x19, 0x00, 0x0a, 0x2c,
	0x00, 0x02, 0x00, 0x02, 0x93, 0xc9, 0x1b, 0x00, 0x09, 0x32, 0x1b,
	0xa0, 0x0f, 0x80, 0xa0, 0x00, 0x00, 0x00, 0x20, 0x02, 0x04, 0x09,
	0xe6, 0x29, 0x11, 0xe0, 0x0c, 0x60, 0x93, 0x06, 0x19, 0xe0, 0x07,
	0x20, 0x98, 0x16, 0x4c, 0xf9, 0x2c, 0x69, 0x06, 0x4d, 0x8c, 0x77,
	0x20, 0x21, 0x54, 0x77, 0x04, 0x01, 0xe7, 0x27, 0x00, 0x03, 0x80,
	0x02, 0x20, 0x00, 0x37, 0x27, 0xa8, 0x67, 0x04, 0x1c, 0x78, 0x7b,
	0x20, 0x22, 0x20, 0x74, 0x14, 0x81, 0xca, 0xc0, 0x20, 0x22, 0x10,
	0x7d, 0x13, 0x00, 0x05, 0x39, 0x98, 0x12, 0x49, 0x81, 0x20, 0x00,
	0x4c, 0x0a, 0xa5, 0xf6, 0x1c, 0x00, 0x04, 0x6b, 0x49, 0x82, 0xa0,
	0x00, 0x98, 0x16, 0x14, 0x00, 0x05, 0x1d, 0xa7, 0xe6, 0x40, 0x00,
	0x27, 0xe0, 0x17, 0x1f, 0xff, 0x5a, 0x00, 0x00, 0x10, 0x03, 0x15,
	0x81, 0x0c, 0x41, 0x00, 0x03, 0x8a, 0x0a, 0xa8, 0x71, 0x81, 0xc0,
	0xb4, 0x71, 0xa8, 0x71, 0x20, 0x03, 0x0b, 0x11, 0xb4, 0x71, 0x06,
	0x40, 0x00, 0x1a, 0x0c, 0x00, 0x08, 0x11, 0xa7, 0xd8, 0xbe, 0x41,
	0x14, 0x80, 0xbe, 0xa0, 0x93, 0x43, 0x06, 0x40, 0x00, 0x1a, 0x0c,
	0x00, 0x10, 0x11, 0xbb, 0x01, 0xa5, 0xe1, 0xba, 0xe1, 0x0f, 0x30,
	0x00, 0x01, 0x08, 0x64, 0x34, 0x18, 0x4c, 0xf8, 0xa0, 0x00, 0x04,
	0x1e, 0x70, 0xd3, 0x17, 0x1f, 0xff, 0x33, 0xac, 0x71, 0x40, 0x00,
	0x2c, 0x70, 0x17, 0x1f, 0xf9, 0x60, 0x4c, 0x41, 0xa0, 0x00, 0xa5,
	0xd1, 0xa8, 0x06, 0x01, 0xf0, 0x00, 0x01, 0x45, 0x30, 0xa5, 0xd6,
	0xb4, 0x51, 0xa8, 0x51, 0x8b, 0xd1, 0xb6, 0x51, 0x0f, 0x30, 0x00,
	0x01, 0x08, 0x64, 0x98, 0x18, 0x17, 0x1f, 0xff, 0x1c, 0x00, 0x00,
	0x20, 0x03, 0xac, 0x70, 0x17, 0x1f, 0xf9, 0x23, 0xac, 0x79, 0x14,
	0x00, 0x0e, 0xc9, 0x0f, 0x30, 0x00, 0x01, 0x08, 0x6a, 0x2c, 0x11,
	0x00, 0x00, 0x10, 0x06, 0xac, 0x06, 0xa5, 0xcf, 0xa0, 0x2f, 0x97,
	0xce, 0x40, 0x00, 0x20, 0x00, 0x0f, 0x30, 0x00, 0x01, 0x0d, 0x6a,
	0x2c, 0x16, 0x00, 0x00, 0x10, 0x01, 0xac, 0x51, 0x06, 0x4e, 0x24,
	0x16, 0x80, 0x40, 0xba, 0x61, 0xa5, 0xcf, 0xa0, 0x2f, 0x97, 0xce,
	0x40, 0x00, 0x20, 0x00, 0xa8, 0x51, 0x0d, 0x04, 0x20, 0x17, 0x06,
	0x4e, 0x20, 0x86, 0x9f, 0xf1, 0x8c, 0x81, 0x0c, 0x58, 0x00, 0x11,
	0x8b, 0x71, 0xac, 0x51, 0xa5, 0xcf, 0xa0, 0x2f, 0x97, 0xce, 0x40,
	0x00, 0x20, 0x00, 0x4c, 0x0a, 0xa0, 0x00, 0x17, 0x1f, 0xfb, 0xd4,
	0x00, 0x00, 0x30, 0xc4, 0xa5, 0xf1, 0x19, 0x00, 0x05, 0xb1, 0xa1,
	0x05, 0x00, 0x00, 0x92, 0x43, 0x00, 0x00, 0x49, 0x23, 0x0f, 0x30,
	0x00, 0x01, 0x17, 0x1f, 0xf9, 0xca, 0x0d, 0x69, 0x80, 0x14, 0x1e,
	0x1f, 0xff, 0x90, 0x06, 0x40, 0x00, 0x1a, 0x0c, 0x00, 0x10, 0x11,
	0xbb, 0x01, 0xa5, 0xe1, 0xba, 0xe1, 0x0f, 0x30, 0x00, 0x01, 0x08,
	0x64, 0x34, 0x12, 0x4c, 0xf8, 0xa0, 0x00, 0x04, 0x1e, 0x70, 0xd3,
	0x17, 0x1f, 0xfe, 0xc1, 0xac, 0x11, 0x40, 0x00, 0x2c, 0x10, 0x17,
	0x1f, 0xf8, 0xee, 0x4c, 0x41, 0xa0, 0x00, 0xa8, 0x76, 0x01, 0xf0,
	0x00, 0x01, 0x8a, 0x61, 0xb4, 0x71, 0xa8, 0x71, 0x8b, 0xd1, 0xb4,
	0x71, 0xa8, 0x71, 0x81, 0xc0, 0xb4, 0x71, 0xa8, 0x71, 0x20, 0x03,
	0x0b, 0x11, 0xb6, 0x71, 0x06, 0x40, 0x00, 0x1a, 0x0c, 0x00, 0x08,
	0x11, 0x1d, 0x83, 0x0a, 0x20, 0x15, 0x83, 0x06, 0xa0, 0x93, 0x43,
	0x4c, 0x0a, 0xa0, 0x00, 0x17, 0x1f, 0xfb, 0x8e, 0x00, 0x00, 0x30,
	0xc4, 0xa5, 0xf1, 0x19, 0x00, 0x05, 0xb1, 0xa1, 0x05, 0x00, 0x00,
	0x92, 0x43, 0x00, 0x00, 0x49, 0x23, 0x0f, 0x30, 0x00, 0x01, 0x17,
	0x1f, 0xf9, 0x84, 0x0d, 0x69, 0x80, 0x14, 0x1e, 0x1f, 0xff, 0x6c,
	0x13, 0x00, 0x04, 0x93, 0x98, 0x12, 0x93, 0x02, 0x1e, 0x1f, 0xff,
	0x20, 0x92, 0x0e, 0xa7, 0x31, 0x0f, 0x30, 0x00, 0x01, 0x0d, 0x6a,
	0x30, 0x11, 0xa7, 0x42, 0xa7, 0x53, 0xa7, 0x64, 0xa7, 0x75, 0xa7,
	0x86, 0xa7, 0x97, 0xa7, 0xa8, 0xa7, 0xb9, 0xa7, 0xca, 0xa7, 0xdb,
	0xa7, 0xec, 0xa7, 0xfd, 0xa7, 0x2f, 0xa8, 0x01, 0x04, 0x89, 0xe8,
	0x11, 0xbc, 0x41, 0xa0, 0x00, 0x1f, 0x1f, 0xfe, 0xa8, 0x0f, 0x30,
	0x00, 0x01, 0x08, 0x6d, 0x30, 0x11, 0x00, 0x00, 0x0f, 0xf6, 0xac,
	0x06, 0xa5, 0x2f, 0xa5, 0x31, 0xa5, 0x42, 0xa5, 0x53, 0xa5, 0x64,
	0xa5, 0x75, 0xa5, 0x86, 0xa5, 0x97, 0xa5, 0xa8, 0xa5, 0xb9, 0xa5,
	0xca, 0xa5, 0xdb, 0xa5, 0xec, 0xa5, 0xfd, 0x97, 0x2e, 0x05, 0xa0,
	0x00, 0x00, 0x49, 0x00, 0xf0, 0x47, 0xf0, 0x04, 0xa7, 0xff, 0xa8,
	0x21, 0xc9, 0xc8, 0x17, 0x1f, 0xf9, 0x40, 0x4c, 0xd1, 0xac, 0x21,
	0xa8, 0x61, 0x64, 0x84, 0x20, 0x00, 0x17, 0x1f, 0xf9, 0x39, 0xb4,
	0x61, 0xa8, 0x61, 0xc9, 0x80, 0xb6, 0x61, 0xa5, 0xff, 0xa0, 0x2f,
	0x97, 0xfe, 0x80, 0x00, 0x80, 0x00, 0x92, 0x01, 0x0f, 0x30, 0x00,
	0x01, 0x0d, 0x61, 0x48, 0x11, 0xa7, 0xff, 0xa8, 0x01, 0x0c, 0x00,
	0x40, 0x11, 0xb8, 0x51, 0xa5, 0xff, 0xa0, 0x2f, 0x97, 0xfe, 0x80,
	0x00, 0x0f, 0x30, 0x00, 0x01, 0x0d, 0x64, 0xe4, 0x11, 0x00, 0x03,
	0x86, 0xc8, 0xa8, 0x06, 0xc9, 0x8d, 0xb6, 0x06, 0xa8, 0x71, 0x80,
	0x40, 0xba, 0xf1, 0x00, 0x00, 0x80, 0x06, 0x00, 0x00, 0x10, 0x07,
	0x0f, 0x50, 0x00, 0x01, 0x0d, 0x10, 0x70, 0x11, 0x07, 0x00, 0x64,
	0x76, 0xa8, 0x06, 0x04, 0x89, 0xb6, 0x66, 0xb6, 0x06, 0x0f, 0x50,
	0x00, 0x01, 0x0d, 0x00, 0x20, 0x11, 0xa8, 0x06, 0xc9, 0xcd, 0xac,
	0x06, 0xa8, 0x06, 0xc9, 0x45, 0x06, 0xff, 0xe4, 0x61, 0xa8, 0x06,
	0xc9, 0x0d, 0xac, 0x06, 0xa8, 0x71, 0x0c, 0x00, 0x02, 0x11, 0xbb,
	0xd1, 0x0f, 0x50, 0x00, 0x02, 0x0d, 0xcf, 0x04, 0x23, 0x17, 0x1f,
	0xf8, 0x28, 0x4c, 0x0a, 0x20, 0x00, 0x0d, 0xc7, 0x00, 0x24, 0x17,
	0x1f, 0xff, 0xa4, 0x0d, 0xc1, 0xf0, 0x23, 0x0f, 0x30, 0x00, 0x08,
	0x0d, 0x68, 0x50, 0x88, 0x0d, 0xc1, 0xe0, 0x24, 0x17, 0x1f, 0xff,
	0x9a, 0x0d, 0xc1, 0xd0, 0x23, 0xa8, 0x71, 0x64, 0x88, 0x20, 0x00,
	0xb6, 0x71, 0x0f, 0x30, 0x00, 0x04, 0x0d, 0x68, 0x4c, 0x44, 0x00,
	0x03, 0x8a, 0x07, 0x4c, 0x39, 0xa8, 0x31, 0xc9, 0x38, 0x4f, 0xf9,
	0x20, 0x00, 0x17, 0x1f, 0xf8, 0x0b, 0xac, 0x31, 0xa8, 0x61, 0x04,
	0x89, 0xbe, 0x11, 0x17, 0x1f, 0xf7, 0xc7, 0xb6, 0x61, 0x06, 0xc1,
	0xe0, 0x14, 0x8c, 0x12, 0x0c, 0x58, 0x00, 0x21, 0x0d, 0x00, 0x58,
	0x11, 0xac, 0x31, 0xa5, 0xff, 0xa0, 0x2f, 0x97, 0xfe, 0x80, 0x00,
	0x49, 0x00, 0xf0, 0x47, 0x49, 0xb1, 0x70, 0x38, 0x49, 0xa9, 0xa7,
	0xff, 0x49, 0x82, 0x28, 0x61, 0xc9, 0x00, 0x17, 0x1f, 0xf8, 0xaf,
	0xb4, 0x61, 0xa8, 0x61, 0x64, 0xc4, 0x20, 0x00, 0x17, 0x1f, 0xf8,
	0xa9, 0xb6, 0x61, 0x49, 0x91, 0xa8, 0x71, 0x04, 0x89, 0xb7, 0x11,
	0xb4, 0x71, 0xa8, 0x71, 0xc9, 0x48, 0x17, 0x1f, 0xf8, 0x9f, 0xb4,
	0x71, 0xa8, 0x71, 0x04, 0x89, 0x97, 0x11, 0xb6, 0x71, 0xa5, 0xff,
	0xa0, 0x2f, 0x97, 0xfe, 0x80, 0x00, 0x92, 0x01, 0x00, 0x03, 0x86,
	0xca, 0xa7, 0xff, 0x06, 0x40, 0x00, 0x1a, 0x0c, 0x00, 0x02, 0x11,
	0x15, 0x80, 0x48, 0x20, 0x0f, 0x50, 0x00, 0x09, 0x0d, 0xc1, 0xe0,
	0x94, 0x0d, 0xc1, 0xd0, 0x93, 0x4c, 0xd2, 0xa0, 0x00, 0x17, 0x1f,
	0xff, 0xca, 0x00, 0x00, 0x20, 0x86, 0x0d, 0xc7, 0x00, 0x94, 0x0d,
	0xc1, 0xf0, 0x93, 0x17, 0x1f, 0xff, 0xc2, 0x00, 0x00, 0x20, 0x86,
	0x0f, 0x30, 0x00, 0x06, 0x0d, 0x68, 0x50, 0x66, 0x0d, 0xcf, 0x04,
	0x93, 0x17, 0x1f, 0xf7, 0xa8, 0x49, 0x82, 0x20, 0x00, 0xa8, 0x51,
	0x64, 0x8c, 0x20, 0x00, 0xb6, 0x51, 0x0f, 0x50, 0x00, 0x01, 0x0d,
	0x00, 0x20, 0x11, 0xa8, 0x06, 0xc9, 0x4d, 0xac, 0x06, 0xa8, 0x06,
	0xc9, 0xc5, 0x06, 0xff, 0xe4, 0x61, 0xa8, 0x06, 0xc9, 0x0d, 0xac,
	0x06, 0x06, 0x40, 0x00, 0x1a, 0x80, 0x40, 0xba, 0xf1, 0x00, 0x00,
	0x80, 0x06, 0x0f, 0x50, 0x00, 0x01, 0x0d, 0x10, 0x70, 0x11, 0xa8,
	0x07, 0x04, 0x89, 0x96, 0x77, 0x00, 0x00, 0x10, 0x08, 0xb6, 0x07,
	0x07, 0x00, 0x65, 0x86, 0x0f, 0x30, 0x00, 0x04, 0x0d, 0x64, 0xe4,
	0x44, 0x00, 0x03, 0x8a, 0x07, 0x4c, 0x31, 0xa8, 0x31, 0xc9, 0x08,
	0x9f, 0xf2, 0x06, 0xf3, 0x68, 0x14, 0xa8, 0x31, 0x64, 0x98, 0x20,
	0x00, 0x17, 0x1f, 0xf7, 0x77, 0xac, 0x31, 0xa8, 0x61, 0x04, 0x89,
	0x9e, 0x11, 0x17, 0x1f, 0xf7, 0x33, 0xb6, 0x61, 0x06, 0xc1, 0xe0,
	0x14, 0x8c, 0x12, 0x0c, 0x58, 0x00, 0x21, 0x0d, 0x00, 0x90, 0x11,
	0xac, 0x31, 0xa5, 0xff, 0xa0, 0x2f, 0x97, 0xfe, 0x80, 0x00, 0x0f,
	0x50, 0x00, 0x01, 0x08, 0x12, 0xa0, 0x12, 0x49, 0x98, 0xa5, 0xec,
	0xa5, 0xfd, 0xa5, 0xc3, 0xb5, 0x11, 0x06, 0xf0, 0x2c, 0x42, 0x06,
	0xf4, 0x40, 0x52, 0x06, 0x76, 0xb8, 0x62, 0x06, 0x7b, 0xb0, 0x72,
	0x06, 0xf4, 0x70, 0x82, 0x06, 0xf0, 0x20, 0x92, 0x06, 0xf0, 0x14,
	0xa2, 0x06, 0xf0, 0x14, 0xd2, 0x16, 0x1f, 0xf8, 0x0b, 0x49, 0x82,
	0x2c, 0x1c, 0x80, 0x00, 0x92, 0x07, 0x0f, 0x30, 0x00, 0x01, 0x0d,
	0x61, 0x48, 0x11, 0xa7, 0x9f, 0xa8, 0x01, 0x0c, 0x00, 0x04, 0x11,
	0xb8, 0x51, 0xa5, 0x9f, 0xa0, 0x2f, 0x97, 0x9e, 0x80, 0x00, 0x0f,
	0x30, 0x00, 0x01, 0x0d, 0x64, 0xe4, 0x11, 0xa8, 0x06, 0xc9, 0x85,
	0xb6, 0x06, 0x00, 0x03, 0x8a, 0x01, 0xa7, 0xb1, 0xa8, 0x01, 0x0c,
	0x80, 0x00, 0x11, 0xb8, 0xf1, 0x0f, 0x30, 0x00, 0x02, 0x0f, 0x50,
	0x01, 0x07, 0x0d, 0xc0, 0x14, 0x77, 0x01, 0xfc, 0xff, 0xf6, 0xa8,
	0x61, 0x8a, 0x61, 0xb5, 0x61, 0xa8, 0x61, 0x8a, 0x16, 0xb6, 0x66,
	0x17, 0x1f, 0xf9, 0x2a, 0x0d, 0x63, 0xf0, 0x23, 0x0f, 0x50, 0x00,
	0x01, 0x08, 0x10, 0xc0, 0x15, 0x17, 0x1f, 0xf9, 0x22, 0x0d, 0x63,
	0xf8, 0x23, 0x0f, 0x04, 0x00, 0x09, 0xa5, 0xb1, 0xac, 0x49, 0xa8,
	0x01, 0x0c, 0x00, 0x02, 0x11, 0x15, 0x01, 0x07, 0x01, 0x00, 0x00,
	0x0f, 0x8a, 0x4d, 0x00, 0xa7, 0xf0, 0x49, 0x83, 0xa7, 0xd0, 0x49,
	0x81, 0xa7, 0xc1, 0x49, 0x84, 0x27, 0xe0, 0x00, 0x01, 0x80, 0x09,
	0x49, 0x83, 0x70, 0x05, 0x17, 0x1f, 0xff, 0x95, 0xf0, 0x04, 0x0f,
	0xc0, 0x3f, 0x01, 0x0d, 0x03, 0x00, 0x11, 0x49, 0x85, 0x27, 0xd0,
	0x4d, 0x00, 0xa7, 0xa1, 0x4c, 0x1b, 0xa7, 0xe0, 0x49, 0x82, 0x27,
	0xc1, 0x49, 0x81, 0xa7, 0xf0, 0x0f, 0x01, 0x02, 0x09, 0x00, 0x00,
	0x06, 0x08, 0x00, 0x40, 0x00, 0x05, 0x17, 0x1f, 0xff, 0x7e, 0x00,
	0x00, 0x20, 0x06, 0x0f, 0x20, 0x00, 0x01, 0x49, 0x84, 0xa7, 0xd0,
	0x49, 0x84, 0x27, 0xf1, 0x49, 0x83, 0xa5, 0xa1, 0x00, 0x10, 0x00,
	0x05, 0x4d, 0x00, 0xa7, 0xe1, 0x49, 0x83, 0x70, 0x03, 0x40, 0x00,
	0x27, 0xc1, 0x17, 0x1f, 0xff, 0x6a, 0x00, 0x00, 0x10, 0x04, 0x0f,
	0x01, 0x02, 0x01, 0x0d, 0x00, 0x01, 0x19, 0x0f, 0x00, 0x18, 0x01,
	0x0d, 0x00, 0x01, 0x18, 0x0f, 0x19, 0x00, 0x01, 0x0d, 0x03, 0x29,
	0x13, 0x4d, 0x00, 0xa7, 0xd0, 0xa7, 0xe0, 0xa7, 0xc1, 0x40, 0x00,
	0x27, 0xf0, 0x00, 0x00, 0x09, 0xc7, 0x00, 0x20, 0x00, 0x05, 0x00,
	0x00, 0x10, 0x06, 0x17, 0x1f, 0xff, 0x4e, 0x0f, 0x20, 0x00, 0x04,
	0x00, 0x00, 0x30, 0x01, 0x49, 0x84, 0xa7, 0xd0, 0x49, 0x83, 0xa7,
	0xe1, 0x0f, 0x02, 0x40, 0x01, 0x0d, 0x02, 0x00, 0x14, 0x0f, 0x00,
	0xe3, 0x01, 0x0d, 0x10, 0x50, 0x13, 0x0f, 0x5e, 0x00, 0x01, 0x49,
	0x84, 0x70, 0x06, 0x4d, 0x00, 0xa7, 0xf1, 0x00, 0x08, 0x00, 0x05,
	0x17, 0x1f, 0xff, 0x34, 0x40, 0x00, 0x27, 0xc1, 0x0f, 0x80, 0x00,
	0x01, 0x49, 0x82, 0xa7, 0xd0, 0x49, 0x82, 0x27, 0xf1, 0x0f, 0x00,
	0x10, 0x01, 0x0d, 0x0c, 0x06, 0x13, 0x4d, 0x00, 0xa7, 0xe0, 0x0f,
	0x00, 0x60, 0x08, 0x17, 0x1f, 0xff, 0x22, 0x4c, 0x83, 0x27, 0xc1,
	0x4d, 0x00, 0xa7, 0xd0, 0x0f, 0x30, 0x00, 0x0b, 0x0d, 0x63, 0x20,
	0xbb, 0x49, 0x84, 0x27, 0xc1, 0x49, 0x83, 0x27, 0xe0, 0x49, 0x81,
	0xa7, 0xf0, 0x00, 0x00, 0x06, 0x07, 0x17, 0x1f, 0xff, 0x10, 0x0f,
	0x80, 0x00, 0x04, 0x06, 0x40, 0x00, 0x1b, 0x0d, 0x0f, 0x00, 0x11,
	0x0f, 0x00, 0xff, 0x06, 0x06, 0x70, 0x00, 0x1b, 0x06, 0x40, 0x00,
	0x1b, 0x04, 0x89, 0x81, 0x17, 0x0d, 0x0f, 0xf2, 0x61, 0x06, 0x70,
	0x00, 0x7b, 0x06, 0x40, 0x00, 0x6b, 0xc9, 0x25, 0x06, 0x70, 0x00,
	0x6b, 0x06, 0x40, 0x00, 0x6b, 0xc9, 0x85, 0x06, 0x70, 0x00, 0x6b,
	0x06, 0x40, 0x00, 0x6b, 0xc9, 0x95, 0x06, 0x70, 0x00, 0x6b, 0x06,
	0x40, 0x00, 0x6b, 0xc9, 0x9d, 0x06, 0xf5, 0x30, 0x6b, 0x06, 0x40,
	0x00, 0x6b, 0xc9, 0x4d, 0x06, 0xfa, 0xcc, 0x6b, 0x06, 0x40, 0x00,
	0x6b, 0x0d, 0x0f, 0x00, 0x66, 0x06, 0xf0, 0x08, 0x6b, 0x06, 0x40,
	0x00, 0x6b, 0x0d, 0x0f, 0x00, 0x66, 0x06, 0xff, 0xf8, 0x6b, 0x06,
	0x40, 0x00, 0x6b, 0xc9, 0x0d, 0x06, 0xf0, 0x08, 0x6b, 0x06, 0x40,
	0x00, 0x6b, 0xc9, 0x0d, 0x06, 0xff, 0xf8, 0x6b, 0x06, 0x40, 0x00,
	0x6b, 0xc9, 0x25, 0x06, 0xf0, 0x08, 0x6b, 0x06, 0x40, 0x00, 0x6b,
	0xc9, 0x25, 0x06, 0xff, 0xf8, 0x6b, 0x06, 0x40, 0x00, 0x6b, 0xc9,
	0x85, 0x06, 0xf0, 0x08, 0x6b, 0x06, 0x40, 0x00, 0x6b, 0xc9, 0x85,
	0x06, 0xff, 0xf8, 0x6b, 0x06, 0x40, 0x00, 0x6b, 0xc9, 0x95, 0x06,
	0xf0, 0x08, 0x6b, 0x06, 0x40, 0x00, 0x6b, 0xc9, 0x95, 0x06, 0xff,
	0xf8, 0x6b, 0x06, 0x40, 0x00, 0x6b, 0xc9, 0x9d, 0x06, 0xf0, 0x08,
	0x6b, 0x06, 0x40, 0x00, 0x6b, 0xc9, 0x9d, 0x06, 0xf0, 0xc4, 0x6b,
	0x06, 0xf4, 0x68, 0x1b, 0x06, 0x40, 0x00, 0x1b, 0xc9, 0x28, 0x06,
	0x70, 0x00, 0x1b, 0x0f, 0x30, 0x00, 0x04, 0x0d, 0x68, 0x4c, 0x44,
	0x98, 0x33, 0x4f, 0xf9, 0x28, 0x31, 0x64, 0x8c, 0x20, 0x00, 0x17,
	0x1f, 0xf5, 0xf7, 0xac, 0x31, 0xa5, 0xb1, 0x93, 0x16, 0xa8, 0x01,
	0x04, 0x89, 0xbd, 0x11, 0x17, 0x1f, 0xf5, 0xb1, 0xb6, 0x51, 0x06,
	0xc1, 0xe0, 0x14, 0x8c, 0x12, 0x0c, 0x58, 0x00, 0x21, 0x0d, 0x00,
	0x06, 0x11, 0xac, 0x31, 0xa5, 0x9f, 0xa0, 0x2f, 0x97, 0x9e, 0x80,
	0x00, 0x0f, 0x50, 0x00, 0x01, 0x08, 0x12, 0xa4, 0x12, 0x49, 0x98,
	0xa5, 0xec, 0xa5, 0xfd, 0xa5, 0xc3, 0xb5, 0x11, 0x06, 0xf0, 0x2c,
	0x42, 0x06, 0xf4, 0x40, 0x52, 0x06, 0x76, 0xb8, 0x62, 0x06, 0x7b,
	0xb0, 0x72, 0x06, 0xf4, 0x70, 0x82, 0x06, 0xf0, 0x20, 0x92, 0x06,
	0xf0, 0x14, 0xa2, 0x06, 0xf0, 0x14, 0xd2, 0x16, 0x1f, 0xf6, 0x89,
	0x49, 0x82, 0x2c, 0x1c, 0x80, 0x00, 0x0f, 0x50, 0x01, 0x06, 0x49,
	0x03, 0x70, 0x31, 0x08, 0x20, 0x04, 0x66, 0x49, 0xb5, 0xa7, 0xaf,
	0x00, 0x03, 0x87, 0x07, 0x00, 0x03, 0x88, 0xc6, 0x06, 0xff, 0xfc,
	0x0b, 0xa8, 0x63, 0xa8, 0x54, 0x00, 0x03, 0x88, 0x06, 0x00, 0x03,
	0x89, 0x87, 0xa8, 0x55, 0x00, 0x03, 0x89, 0xc6, 0x00, 0x03, 0x86,
	0x88, 0xa8, 0x56, 0xa8, 0x67, 0xa8, 0x7d, 0x00, 0x03, 0x86, 0x08,
	0x00, 0x03, 0x86, 0x42, 0xa8, 0x79, 0x00, 0x03, 0x87, 0x88, 0xa7,
	0xb1, 0xa8, 0x7a, 0x00, 0x03, 0x87, 0x48, 0xa8, 0x7c, 0x00, 0x03,
	0x89, 0x48, 0xa8, 0x78, 0x4f, 0xf9, 0x28, 0x1f, 0x04, 0x06, 0xe2,
	0xf1, 0x8c, 0x2c, 0x46, 0x14, 0x27, 0xd1, 0x00, 0x00, 0x05, 0xe1,
	0x46, 0x11, 0xa7, 0xe8, 0x46, 0x12, 0x27, 0xfc, 0x46, 0x12, 0xa7,
	0xc1, 0x8c, 0x26, 0x8c, 0x27, 0x8c, 0x29, 0x8c, 0x2a, 0x17, 0x1f,
	0xff, 0xa4, 0x04, 0x06, 0xe2, 0xd8, 0x06, 0x40, 0x00, 0x1b, 0xc9,
	0x40, 0x00, 0x10, 0x00, 0x06, 0x06, 0xf0, 0x00, 0x1b, 0x06, 0x40,
	0x00, 0x1b, 0xc9, 0x08, 0x0f, 0x80, 0x00, 0x07, 0x06, 0xff, 0xf0,
	0x1b, 0x00, 0x00, 0x80, 0x01, 0x07, 0x00, 0x64, 0x61, 0x17, 0x1f,
	0xf5, 0x48, 0x07, 0x00, 0x64, 0x71, 0x0f, 0xdf, 0xff, 0x01, 0x0d,
	0x48, 0x5c, 0x11, 0x44, 0x58, 0xa5, 0xb7, 0xa8, 0x06, 0x8b, 0x76,
	0xb6, 0x06, 0xa5, 0xaf, 0xa0, 0x2f, 0x97, 0xae, 0x80, 0x00, 0x80,
	0x00, 0x92, 0x03, 0x0f, 0x30, 0x00, 0x01, 0x0d, 0x64, 0xe4, 0x11,
	0xa7, 0xdf, 0xa8, 0x01, 0x0c, 0x00, 0x02, 0x11, 0x1c, 0x80, 0x0a,
	0x22, 0xa0, 0x00, 0x1f, 0x1f, 0xfd, 0x7e, 0x00, 0x03, 0x8a, 0x06,
	0x0f, 0x50, 0x00, 0x01, 0x40, 0x00, 0x27, 0xf6, 0x0d, 0xc8, 0x10,
	0x14, 0x0d, 0xc8, 0x00, 0x13, 0x00, 0x00, 0x04, 0xe5, 0x17, 0x1f,
	0xfd, 0x4c, 0x00, 0x00, 0x61, 0x86, 0xa5, 0xf1, 0xa8, 0x01, 0x04,
	0x89, 0xf7, 0x11, 0x14, 0x81, 0x08, 0x20, 0xa5, 0xf1, 0xa8, 0x01,
	0x04, 0x89, 0xf6, 0x11, 0xbb, 0x41, 0x0f, 0x30, 0x00, 0x08, 0xa0,
	0x00, 0x17, 0x1f, 0xf7, 0x58, 0x0d, 0x64, 0xf0, 0x83, 0x17, 0x1f,
	0xf7, 0x54, 0x0d, 0x64, 0xf4, 0x83, 0x0f, 0x30, 0x00, 0x01, 0x0d,
	0x68, 0x4c, 0x11, 0xa8, 0x06, 0x04, 0x89, 0x96, 0x66, 0xb6, 0x06,
	0x0f, 0x30, 0x00, 0x08, 0x0d, 0x68, 0x4c, 0x88, 0xa8, 0x71, 0xc9,
	0xf0, 0xb4, 0x71, 0xa5, 0xf1, 0xa8, 0x01, 0x0c, 0x00, 0x04, 0x11,
	0xba, 0xf1, 0x0f, 0x30, 0x00, 0x02, 0x17, 0x1f, 0xfa, 0xe0, 0x4c,
	0x09, 0xa0, 0x00, 0x0f, 0x30, 0x00, 0x01, 0x0d, 0x62, 0x2c, 0x11,
	0xa8, 0x06, 0x64, 0xce, 0xa0, 0x00, 0xb6, 0x06, 0xa5, 0xf1, 0xa8,
	0x01, 0x04, 0x89, 0xf0, 0x11, 0xbe, 0xa1, 0xa0, 0x00, 0x17, 0x1f,
	0xf7, 0x28, 0x0d, 0x62, 0x90, 0x23, 0xa8, 0x71, 0x04, 0x89, 0x90,
	0x11, 0xb6, 0x71, 0x00, 0x03, 0x86, 0xc1, 0xa8, 0x01, 0x04, 0x89,
	0xf4, 0x11, 0xbf, 0x11, 0x17, 0x1f, 0xf7, 0x1a, 0x0d, 0x63, 0xd8,
	0x23, 0x17, 0x1f, 0xf7, 0x16, 0x0d, 0x63, 0xdc, 0x23, 0x17, 0x1f,
	0xf7, 0x12, 0x0d, 0x63, 0xe0, 0x23, 0x17, 0x1f, 0xf7, 0x0e, 0x0d,
	0x63, 0xd4, 0x23, 0x0f, 0x30, 0x00, 0x01, 0x0d, 0x60, 0xac, 0x11,
	0x99, 0x03, 0xa8, 0x06, 0xc9, 0x95, 0x06, 0xf3, 0xf4, 0x61, 0xa8,
	0x06, 0xc9, 0x8d, 0x06, 0xf5, 0x8c, 0x61, 0x17, 0x1f, 0xff, 0x13,
	0xa7, 0xe1, 0x17, 0x1f, 0xf4, 0xd2, 0x4c, 0x21, 0xa0, 0x00, 0x4f,
	0xf9, 0x25, 0xf1, 0x49, 0x8b, 0x20, 0x00, 0xa8, 0x01, 0x04, 0x89,
	0x9f, 0x11, 0x17, 0x1f, 0xf4, 0x89, 0xb6, 0x51, 0xa5, 0xe1, 0x93,
	0x16, 0x06, 0x4e, 0x20, 0x11, 0x8c, 0x12, 0x0c, 0x58, 0x00, 0x21,
	0x0d, 0x05, 0x20, 0x11, 0xac, 0x51, 0xa5, 0xdf, 0xa0, 0x2f, 0x97,
	0xde, 0x80, 0x00, 0x1f, 0x00, 0x06, 0x9c, 0x1e, 0x1f, 0xff, 0x94,
	0x92, 0x07, 0x00, 0x03, 0x8a, 0x0b, 0xa7, 0x9f, 0x06, 0x40, 0x00,
	0x1b, 0x0c, 0x00, 0x02, 0x11, 0x14, 0x80, 0xac, 0x20, 0x0f, 0x30,
	0x00, 0x01, 0x06, 0x40, 0x00, 0x1b, 0x0c, 0x80, 0x00, 0x11, 0xb9,
	0x21, 0x00, 0x00, 0xa2, 0x83, 0x0f, 0x50, 0x01, 0x01, 0x0d, 0xc0,
	0x14, 0x11, 0x49, 0x82, 0x28, 0x06, 0x64, 0xb2, 0xa0, 0x00, 0xb5,
	0x06, 0xa8, 0x06, 0x0d, 0x30, 0x00, 0x66, 0x17, 0x1f, 0xf5, 0x55,
	0xb6, 0x06, 0x0f, 0x30, 0x00, 0x02, 0x49, 0x82, 0x20, 0x00, 0x17,
	0x1f, 0xf5, 0x4e, 0x00, 0x01, 0x45, 0x03, 0x17, 0x1f, 0xf6, 0xd6,
	0x0d, 0x63, 0xf8, 0x23, 0x17, 0x1f, 0xf6, 0xd2, 0x0d, 0x63, 0xf0,
	0x23, 0x0f, 0x50, 0x00, 0x08, 0x08, 0x10, 0xc4, 0x81, 0x0f, 0x04,
	0x00, 0x06, 0x0f, 0xe0, 0x00, 0x02, 0x0d, 0x54, 0x20, 0x22, 0x44,
	0x09, 0x2c, 0x06, 0x98, 0x23, 0x4f, 0xfa, 0x28, 0x11, 0xc9, 0x00,
	0x06, 0xf3, 0x68, 0x12, 0xa8, 0x11, 0x64, 0x88, 0x20, 0x00, 0x17,
	0x1f, 0xf4, 0x6b, 0xac, 0x11, 0x06, 0x40, 0x00, 0x1b, 0x04, 0x89,
	0x9d, 0x11, 0x17, 0x1f, 0xf4, 0x26, 0x06, 0xff, 0xf0, 0x1b, 0x06,
	0xc1, 0xe0, 0x12, 0x8c, 0x14, 0x0c, 0x58, 0x00, 0x41, 0x0d, 0x00,
	0x58, 0x11, 0xac, 0x11, 0xa5, 0x9f, 0xa0, 0x2f, 0x97, 0x9e, 0x80,
	0x00, 0x08, 0x63, 0xe8, 0x12, 0x00, 0x00, 0xff, 0x21, 0x93, 0x04,
	0x06, 0xff, 0x34, 0x12, 0x4d, 0x01, 0xa8, 0x11, 0xc9, 0x10, 0x0f,
	0x20, 0x20, 0x07, 0x0d, 0x7c, 0xb4, 0x77, 0xb5, 0x11, 0xa8, 0x11,
	0xc9, 0x10, 0x00, 0x00, 0x30, 0x0c, 0x17, 0x1f, 0xf5, 0x03, 0xb7,
	0x11, 0xa8, 0x11, 0xc9, 0x18, 0x0f, 0xde, 0x00, 0x05, 0xb5, 0x11,
	0xa8, 0x11, 0xc9, 0x18, 0x0f, 0x01, 0x02, 0x08, 0x17, 0x1f, 0xf4,
	0xf7, 0xb7, 0x11, 0xa8, 0x11, 0xc9, 0xa0, 0x0f, 0xc0, 0x3f, 0x06,
	0xb5, 0x11, 0xa8, 0x11, 0xc9, 0xa0, 0x0d, 0x03, 0x00, 0x66, 0xb7,
	0x11, 0xa8, 0x11, 0xc9, 0x88, 0x0d, 0x00, 0x01, 0x89, 0xb5, 0x11,
	0xa8, 0x11, 0xc9, 0x88, 0x0f, 0x19, 0xf3, 0x0a, 0xb7, 0x11, 0xa8,
	0x11, 0xc9, 0x00, 0x0f, 0xa2, 0x40, 0x0d, 0xb5, 0x11, 0xa8, 0x11,
	0x64, 0x80, 0x27, 0xb6, 0x0f, 0x00, 0x78, 0x08, 0xb7, 0x11, 0xa8,
	0x11, 0xc9, 0xc0, 0x0d, 0x00, 0x01, 0x88, 0x17, 0x1f, 0xf4, 0xd1,
	0xb5, 0x11, 0xa8, 0x11, 0x64, 0xe0, 0x20, 0x00, 0x17, 0x1f, 0xf4,
	0xcb, 0xb7, 0x11, 0xa8, 0x11, 0x64, 0xe4, 0x20, 0x00, 0x17, 0x1f,
	0xf4, 0xc5, 0xb5, 0x11, 0xa8, 0x11, 0x64, 0xe4, 0x20, 0x00, 0x17,
	0x1f, 0xf4, 0xbf, 0xb7, 0x11, 0xa8, 0x11, 0x64, 0xe8, 0x20, 0x00,
	0x17, 0x1f, 0xf4, 0xb9, 0xb5, 0x11, 0xa8, 0x11, 0x64, 0xe8, 0x20,
	0x00, 0x17, 0x1f, 0xf4, 0xb3, 0xb7, 0x11, 0xa8, 0x11, 0x64, 0xec,
	0x20, 0x00, 0x17, 0x1f, 0xf4, 0xad, 0xb5, 0x11, 0xa8, 0x11, 0xc9,
	0xd8, 0x17, 0x1f, 0xf4, 0xa8, 0x06, 0xf5, 0x2c, 0x12, 0xa8, 0x11,
	0xc9, 0x30, 0x06, 0xfa, 0xd0, 0x12, 0xa8, 0x11, 0x64, 0x88, 0x20,
	0x00, 0x17, 0x1f, 0xf4, 0x9d, 0xac, 0x11, 0xa8, 0x11, 0x64, 0x8c,
	0x20, 0x00, 0x17, 0x1f, 0xf4, 0x97, 0xac, 0x11, 0xa8, 0x11, 0xc9,
	0xa0, 0xac, 0x11, 0xa8, 0x11, 0xc9, 0x88, 0xac, 0x11, 0xa8, 0x11,
	0xc9, 0x00, 0xac, 0x11, 0xa8, 0x11, 0xc9, 0xc0, 0x17, 0x1f, 0xf4,
	0x89, 0xac, 0x11, 0xa8, 0x11, 0x64, 0xe4, 0x20, 0x00, 0x17, 0x1f,
	0xf4, 0x83, 0xac, 0x11, 0xa8, 0x11, 0xc9, 0xd0, 0x17, 0x1f, 0xf4,
	0x7e, 0x06, 0xf5, 0x30, 0x12, 0x44, 0x13, 0xa8, 0x11, 0x64, 0xa8,
	0x27, 0xec, 0x4d, 0x03, 0x27, 0xa7, 0xac, 0x11, 0xa7, 0xf5, 0xa7,
	0xc6, 0xa7, 0xd0, 0x0d, 0x1f, 0x7f, 0xa3, 0x0d, 0x02, 0x00, 0xd4,
	0x49, 0x85, 0x20, 0x00, 0x00, 0x00, 0x0f, 0xc7, 0x00, 0x28, 0x00,
	0x05, 0x17, 0x1f, 0xfd, 0xc4, 0x00, 0x00, 0x11, 0x06, 0x4c, 0x1b,
	0xa5, 0xb1, 0x49, 0x81, 0xa7, 0xd0, 0xa7, 0xe1, 0x0f, 0x20, 0x00,
	0x01, 0x0f, 0x01, 0x02, 0x09, 0x4d, 0x00, 0xa7, 0xf1, 0x00, 0x00,
	0x06, 0x08, 0xa7, 0xc1, 0x00, 0x50, 0x00, 0x05, 0x00, 0x00, 0x20,
	0x06, 0x17, 0x1f, 0xfd, 0xae, 0x00, 0x00, 0x10, 0x04, 0x4d, 0x00,
	0xa7, 0xd0, 0x49, 0x84, 0x27, 0xe0, 0x49, 0x83, 0xa7, 0xc1, 0x49,
	0x83, 0x27, 0xf0, 0x00, 0x00, 0x0f, 0x8a, 0x00, 0x01, 0x80, 0x09,
	0x49, 0x82, 0xf0, 0x04, 0x17, 0x1f, 0xfd, 0x9c, 0x40, 0x00, 0x70,
	0x03, 0x4c, 0x08, 0xa5, 0xa6, 0x16, 0x1f, 0xfe, 0xd0, 0xac, 0x51,
	0x80, 0x00, 0x92, 0x01, 0x00, 0x03, 0x8a, 0x01, 0xa7, 0xff, 0xa8,
	0x01, 0x04, 0x89, 0xf2, 0x11, 0xb8, 0x51, 0xa5, 0xff, 0xa0, 0x2f,
	0x97, 0xfe, 0x80, 0x00, 0x0f, 0x30, 0x00, 0x07, 0x0d, 0x68, 0x4c,
	0x77, 0x49, 0x82, 0x20, 0x00, 0x17, 0x1f, 0xf4, 0x22, 0x00, 0x00,
	0x04, 0xe3, 0xa8, 0x61, 0x04, 0x89, 0x91, 0x11, 0xb6, 0x61, 0xa5,
	0xff, 0xa0, 0x2f, 0x97, 0xfe, 0x80, 0x00, 0x92, 0x01, 0x00, 0x03,
	0x8a, 0x01, 0xa7, 0xff, 0xa8, 0x01, 0x04, 0x89, 0xf1, 0x11, 0xbf,
	0xd1, 0x0f, 0x30, 0x00, 0x01, 0x0d, 0x61, 0x48, 0x11, 0xa8, 0x06,
	0x0c, 0x10, 0x00, 0x66, 0x14, 0x83, 0xfa, 0xc0, 0x0f, 0x30, 0x00,
	0x07, 0x93, 0x04, 0x17, 0x1f, 0xf4, 0x02, 0x00, 0x00, 0x04, 0xe3,
	0x17, 0x1f, 0xf5, 0x4c, 0x0d, 0x63, 0xcc, 0x73, 0x0f, 0x30, 0x00,
	0x01, 0x0d, 0x68, 0x4c, 0x11, 0xa8, 0x06, 0x04, 0x89, 0x93, 0x66,
	0xb6, 0x06, 0x0f, 0x30, 0x00, 0x01, 0x0d, 0x68, 0x4c, 0x11, 0xa8,
	0x06, 0xc9, 0x65, 0xb6, 0x06, 0xa5, 0xff, 0xa0, 0x2f, 0x97, 0xfe,
	0x80, 0x00, 0x80, 0x00, 0x92, 0x01, 0x00, 0x03, 0x8a, 0x01, 0xa7,
	0xff, 0xa8, 0x01, 0x04, 0x89, 0xf6, 0x11, 0xb8, 0x51, 0xa5, 0xff,
	0xa0, 0x2f, 0x97, 0xfe, 0x80, 0x00, 0x0f, 0x30, 0x00, 0x02, 0x17,
	0x1f, 0xf5, 0x26, 0x0d, 0x64, 0xf4, 0x23, 0x17, 0x1f, 0xf5, 0x22,
	0x0d, 0x64, 0xf0, 0x23, 0x0f, 0x30, 0x00, 0x01, 0x0d, 0x68, 0x4c,
	0x11, 0xa8, 0x06, 0x04, 0x89, 0x95, 0x66, 0xb6, 0x06, 0xa5, 0xff,
	0xa0, 0x2f, 0x97, 0xfe, 0x80, 0x00, 0x92, 0x08, 0x0f, 0x30, 0x00,
	0x01, 0x0d, 0x61, 0x48, 0x11, 0xa7, 0x8f, 0xa7, 0xb1, 0xa8, 0x01,
	0x0c, 0x00, 0x10, 0x11, 0x15, 0x01, 0x94, 0x01, 0x00, 0x00, 0x80,
	0x06, 0x00, 0x10, 0x00, 0x07, 0x0f, 0x80, 0x00, 0x08, 0x0f, 0x30,
	0x00, 0x02, 0x0d, 0x66, 0x7c, 0x22, 0x07, 0x00, 0x65, 0x76, 0x07,
	0x00, 0x65, 0x86, 0xa8, 0x16, 0x00, 0x0b, 0x98, 0x81, 0x0c, 0x0f,
	0x00, 0x66, 0x04, 0x89, 0x9d, 0x11, 0x88, 0x21, 0x04, 0x1c, 0x64,
	0x66, 0xb6, 0x06, 0xa5, 0xb1, 0xa8, 0x01, 0x04, 0x89, 0xe8, 0x11,
	0xbc, 0x91, 0x1f, 0x1f, 0xf8, 0xe2, 0xa5, 0xb1, 0xa8, 0x01, 0x04,
	0x89, 0xe8, 0x11, 0x1d, 0x83, 0xf4, 0x20, 0x1f, 0x1f, 0xf2, 0xb2,
	0x0f, 0xc0, 0x00, 0x01, 0x0f, 0x00, 0x3f, 0x02, 0x0d, 0x04, 0x00,
	0x11, 0x00, 0x00, 0x05, 0xea, 0x0f, 0x01, 0x02, 0x06, 0x0d, 0x03,
	0x00, 0x22, 0x0d, 0x00, 0x10, 0x69, 0x0f, 0x08, 0x00, 0x06, 0x49,
	0x85, 0x27, 0xca, 0x4c, 0x7b, 0xa7, 0xe1, 0xa7, 0xf0, 0xa7, 0xd0,
	0x0d, 0x00, 0x21, 0x63, 0x40, 0x00, 0x27, 0xa2, 0x00, 0x00, 0x06,
	0x08, 0x00, 0x60, 0x00, 0x05, 0x0f, 0x00, 0x18, 0x04, 0x17, 0x1f,
	0xfb, 0x4c, 0x00, 0x00, 0x30, 0x06, 0x49, 0x84, 0xa5, 0xa1, 0x00,
	0x28, 0x00, 0x9b, 0x48, 0xed, 0xa7, 0xe1, 0x0f, 0x30, 0x00, 0x01,
	0x49, 0x84, 0x27, 0xd0, 0x49, 0x83, 0xa7, 0xf1, 0x00, 0x00, 0x05,
	0xe1, 0x49, 0x82, 0xf0, 0x06, 0x49, 0x82, 0x27, 0xc1, 0x0f, 0x00,
	0xe0, 0x01, 0x17, 0x1f, 0xfb, 0x34, 0x0d, 0x00, 0x40, 0x13, 0x06,
	0x40, 0x00, 0x1b, 0x04, 0x89, 0xa1, 0x16, 0x0f, 0xdf, 0xff, 0x01,
	0x0d, 0x44, 0xb0, 0x11, 0x06, 0xf0, 0x00, 0x6b, 0x06, 0x40, 0x00,
	0x6b, 0xc9, 0xc5, 0x00, 0x00, 0x61, 0x88, 0x06, 0xff, 0xf0, 0x6b,
	0x88, 0xb1, 0x00, 0x00, 0x14, 0x06, 0xa8, 0x07, 0xc9, 0x0e, 0xb4,
	0x07, 0xa7, 0xa1, 0x00, 0x00, 0x14, 0x01, 0xf3, 0x40, 0x17, 0x00,
	0x03, 0x93, 0xf2, 0xbd, 0x15, 0x81, 0xbc, 0x20, 0xa5, 0xa1, 0xa8,
	0x01, 0x04, 0x89, 0xee, 0x11, 0xbf, 0x61, 0x0f, 0x30, 0x00, 0x06,
	0x0d, 0x68, 0x50, 0x66, 0xa0, 0x00, 0x00, 0x00, 0x14, 0x01, 0xf3,
	0x40, 0xbc, 0x71, 0xa8, 0x51, 0x04, 0x89, 0x99, 0x17, 0x49, 0xb0,
	0xa0, 0x00, 0xb6, 0x07, 0xa5, 0xa1, 0xa8, 0x01, 0x04, 0x89, 0xee,
	0x11, 0x1c, 0x83, 0xe4, 0x20, 0x00, 0x00, 0x14, 0x01, 0x00, 0x03,
	0x86, 0xc2, 0xf3, 0x40, 0x00, 0x00, 0x14, 0x01, 0x07, 0x00, 0x62,
	0x01, 0xa8, 0x11, 0x04, 0x89, 0xf8, 0x11, 0xbe, 0x81, 0x0f, 0x30,
	0x00, 0x01, 0x0d, 0x60, 0xac, 0x11, 0xa8, 0x06, 0xc9, 0x15, 0xb6,
	0x06, 0x0f, 0x30, 0x00, 0x01, 0x0d, 0x68, 0x4c, 0x11, 0xa7, 0x91,
	0xa8, 0x01, 0x04, 0x89, 0xeb, 0x11, 0xbe, 0xa1, 0xa0, 0x00, 0x1f,
	0x1f, 0xfe, 0xc8, 0xa5, 0x91, 0x93, 0x16, 0xa8, 0x01, 0x64, 0xac,
	0x20, 0x00, 0xb6, 0x51, 0xa5, 0x91, 0xa8, 0x01, 0x04, 0x89, 0xec,
	0x11, 0xbe, 0x41, 0xa0, 0x00, 0x1f, 0x1f, 0xfe, 0xd8, 0xa8, 0x11,
	0x04, 0x89, 0xf4, 0x11, 0xbb, 0x91, 0x0f, 0x30, 0x00, 0x01, 0x17,
	0x1f, 0xf4, 0x34, 0x0d, 0x63, 0xd8, 0x13, 0x0f, 0x30, 0x00, 0x01,
	0x17, 0x1f, 0xf4, 0x2e, 0x0d, 0x63, 0xdc, 0x13, 0x0f, 0x30, 0x00,
	0x01, 0x17, 0x1f, 0xf4, 0x28, 0x0d, 0x63, 0xe0, 0x13, 0x0f, 0x30,
	0x00, 0x01, 0x17, 0x1f, 0xf4, 0x22, 0x0d, 0x63, 0xd4, 0x13, 0x00,
	0x03, 0x8a, 0x01, 0xa7, 0xa1, 0xa8, 0x01, 0x04, 0x89, 0xf0, 0x11,
	0xba, 0xe1, 0x0f, 0x30, 0x00, 0x01, 0xa0, 0x00, 0x17, 0x1f, 0xf4,
	0x14, 0x0d, 0x62, 0x90, 0x13, 0xa5, 0x91, 0x93, 0x16, 0xa8, 0x01,
	0x64, 0xbc, 0x20, 0x00, 0xb6, 0x51, 0xa5, 0xa1, 0xa8, 0x01, 0x04,
	0x89, 0xf7, 0x11, 0xbb, 0x01, 0xa5, 0xa1, 0xa8, 0x01, 0x04, 0x89,
	0xf6, 0x11, 0xba, 0xb1, 0x0f, 0x50, 0x94, 0x01, 0x08, 0x70, 0x90,
	0x16, 0x98, 0x17, 0x0f, 0x00, 0x10, 0x01, 0x44, 0x30, 0xac, 0x57,
	0xac, 0x07, 0xa5, 0xa1, 0xa8, 0x01, 0x0c, 0x00, 0x04, 0x11, 0xba,
	0xc1, 0x98, 0x83, 0x0f, 0x30, 0x00, 0x01, 0x0d, 0x62, 0x2c, 0x11,
	0xa8, 0x06, 0x64, 0x8e, 0xa0, 0x00, 0x17, 0x1f, 0xf7, 0xa7, 0xb6,
	0x06, 0xa5, 0xb1, 0xa8, 0x01, 0x0c, 0x40, 0x00, 0x11, 0x14, 0x83,
	0xf8, 0x20, 0xa5, 0xa1, 0xa8, 0x01, 0x04, 0x89, 0xf7, 0x11, 0xbe,
	0x61, 0xa0, 0x00, 0x1f, 0x00, 0x03, 0x5e, 0x40, 0x00, 0x21, 0x84,
	0x1f, 0x1f, 0xfe, 0xa2, 0x0f, 0x50, 0x00, 0x01, 0x0d, 0xc8, 0x00,
	0x13, 0x17, 0x1f, 0xf9, 0x3c, 0x0d, 0xc8, 0x10, 0x14, 0x4c, 0x29,
	0xa5, 0x91, 0x4f, 0xf9, 0x25, 0x96, 0xa8, 0x01, 0xc9, 0x70, 0xac,
	0x51, 0xa8, 0x51, 0xc9, 0x28, 0x17, 0x1f, 0xf1, 0xb3, 0xac, 0x51,
	0xa5, 0xa1, 0xa8, 0x01, 0x04, 0x89, 0xbf, 0x16, 0xa5, 0xa1, 0xb4,
	0x06, 0xa8, 0x06, 0x04, 0x89, 0x9b, 0x66, 0x17, 0x1f, 0xf1, 0x69,
	0xb6, 0x06, 0xa5, 0x91, 0x06, 0xc1, 0xe0, 0x61, 0x8c, 0x62, 0x0c,
	0x58, 0x00, 0x26, 0x0d, 0x00, 0x90, 0x66, 0xac, 0x06, 0xa5, 0x8f,
	0xa0, 0x2f, 0x97, 0x8e, 0x40, 0x00, 0x20, 0x00, 0x4c, 0x09, 0x25,
	0xa6, 0x0f, 0x20, 0xa4, 0x01, 0x0d, 0x0c, 0x38, 0x11, 0x44, 0x30,
	0xa8, 0x56, 0x04, 0x89, 0xee, 0x67, 0xab, 0x86, 0x80, 0x6d, 0x04,
	0x01, 0xe7, 0x27, 0x04, 0x01, 0xe6, 0x26, 0x8b, 0x76, 0x1c, 0x82,
	0x5a, 0xc0, 0x0f, 0x30, 0x00, 0x07, 0x0d, 0x68, 0x50, 0x77, 0xa0,
	0x00, 0x00, 0x00, 0x14, 0x06, 0xf3, 0x6d, 0xbc, 0x76, 0xa8, 0x66,
	0x04, 0x89, 0x99, 0x68, 0x49, 0xbb, 0x20, 0x00, 0xb6, 0x58, 0xa5,
	0xa6, 0xa8, 0x56, 0x04, 0x89, 0xee, 0x66, 0x04, 0x01, 0xe6, 0x28,
	0xab, 0x86, 0x80, 0x6d, 0x04, 0x01, 0xe6, 0x26, 0x8b, 0x86, 0x1d,
	0x83, 0xd6, 0xc0, 0x1e, 0x1f, 0xff, 0x0f, 0xa0, 0x00, 0xa5, 0x8f,
	0xa0, 0x2f, 0x97, 0x8e, 0x80, 0x00, 0x92, 0x07, 0x0f, 0x30, 0x00,
	0x01, 0x08, 0x60, 0x74, 0x16, 0xa7, 0x9f, 0x06, 0xf7, 0xd8, 0x06,
	0x06, 0x4e, 0x30, 0x76, 0x04, 0x1e, 0x78, 0x77, 0x0f, 0xf0, 0x00,
	0x01, 0x8b, 0x71, 0x0f, 0x80, 0x00, 0x07, 0xb4, 0xd1, 0x0d, 0x00,
	0x01, 0x71, 0x00, 0x03, 0x8a, 0x07, 0x00, 0x03, 0x87, 0x08, 0xa7,
	0xf7, 0xb4, 0xd1, 0xa8, 0x67, 0x0f, 0x1f, 0xff, 0x01, 0x0d, 0x99,
	0xe0, 0x11, 0x06, 0xfd, 0xe0, 0x76, 0xa7, 0xe6, 0xb4, 0xd0, 0xb4,
	0xd0, 0xb4, 0xd0, 0x44, 0x30, 0xac, 0x50, 0x08, 0x16, 0xf4, 0x12,
	0xa8, 0x06, 0x81, 0x2d, 0x00, 0x03, 0x89, 0x01, 0x00, 0x03, 0x88,
	0x07, 0xac, 0x06, 0x06, 0x4b, 0x8c, 0x12, 0x00, 0x03, 0x88, 0xc6,
	0x4f, 0xfc, 0x2c, 0x71, 0x06, 0x4b, 0x94, 0x12, 0xac, 0x51, 0x06,
	0x4b, 0xc0, 0x12, 0x00, 0x03, 0x89, 0xc6, 0xac, 0x61, 0x06, 0x46,
	0xb8, 0x12, 0x00, 0x03, 0x89, 0x87, 0xac, 0x51, 0x06, 0x4b, 0xb0,
	0x12, 0x00, 0x03, 0x86, 0x86, 0xac, 0x61, 0xa8, 0x11, 0x00, 0x03,
	0x86, 0x07, 0xac, 0x51, 0x06, 0x44, 0x70, 0x12, 0x00, 0x03, 0x87,
	0x86, 0xac, 0x61, 0x06, 0x44, 0x90, 0x12, 0x00, 0x03, 0x87, 0x47,
	0xac, 0x51, 0x06, 0x44, 0xa4, 0x62, 0x0f, 0xe0, 0x00, 0x01, 0x0d,
	0x53, 0x0c, 0x11, 0x44, 0x10, 0xac, 0x66, 0x06, 0x44, 0xb8, 0x62,
	0x00, 0x03, 0x89, 0x47, 0xac, 0x66, 0x06, 0xfe, 0x2c, 0x81, 0xa7,
	0xd1, 0xa5, 0xf1, 0xa8, 0x01, 0x0c, 0x01, 0x00, 0x11, 0xba, 0x81,
	0x00, 0x00, 0x80, 0x01, 0x00, 0x01, 0x00, 0x06, 0x07, 0x00, 0x65,
	0x61, 0xa0, 0x00, 0xa5, 0xf1, 0xa8, 0x01, 0x0c, 0x02, 0x00, 0x11,
	0xb9, 0xa1, 0x0f, 0x51, 0x00, 0x06, 0x00, 0x0b, 0x03, 0xc1, 0x44,
	0x30, 0xa0, 0x00, 0x00, 0x00, 0x10, 0xe7, 0x0f, 0x00, 0x26, 0x06,
	0x0d, 0xcd, 0x00, 0x66, 0x06, 0xf1, 0x00, 0x71, 0x06, 0xf1, 0x00,
	0x71, 0x06, 0xf1, 0x00, 0x71, 0x44, 0x0b, 0x2c, 0x07, 0x06, 0xf1,
	0x00, 0x76, 0x06, 0xf1, 0x00, 0x76, 0xac, 0x57, 0x0f, 0x30, 0x00,
	0x01, 0x0d, 0x6a, 0x30, 0x11, 0x0f, 0x00, 0x80, 0x06, 0xa7, 0xc1,
	0x0f, 0x30, 0x00, 0x01, 0x0d, 0x6a, 0x2c, 0x11, 0x0d, 0x1f, 0xfc,
	0x66, 0xa7, 0xb1, 0xa5, 0xb7, 0x00, 0x00, 0x52, 0x01, 0x00, 0x00,
	0x40, 0x03, 0xac, 0x61, 0x06, 0x72, 0xd4, 0x67, 0x00, 0x00, 0x10,
	0x01, 0x0f, 0x01, 0x94, 0x06, 0x17, 0x1f, 0xf6, 0x84, 0x07, 0x00,
	0x65, 0x61, 0x00, 0x00, 0x10, 0x01, 0xf3, 0x80, 0x04, 0x89, 0xf2,
	0x11, 0x15, 0x81, 0x66, 0x20, 0xa5, 0xe1, 0xa8, 0x01, 0x15, 0x81,
	0x5e, 0x20, 0x00, 0x00, 0x10, 0x01, 0xf3, 0x80, 0x04, 0x89, 0xf3,
	0x11, 0x15, 0x80, 0xf8, 0x20, 0x40, 0x00, 0x25, 0xc1, 0x00, 0x00,
	0x10, 0x01, 0x40, 0x00, 0x73, 0x80, 0x04, 0x89, 0xf4, 0x11, 0x15,
	0x80, 0xb4, 0x20, 0x00, 0x00, 0x80, 0x01, 0x00, 0x00, 0x10, 0x01,
	0xf3, 0x80, 0x04, 0x89, 0xf6, 0x11, 0xbb, 0xd1, 0x40, 0x00, 0x25,
	0xc1, 0x00, 0x00, 0x80, 0x01, 0x00, 0x04, 0x84, 0x06, 0x05, 0x80,
	0x00, 0x00, 0x07, 0x00, 0x64, 0x61, 0xa5, 0xf1, 0xa8, 0x01, 0x04,
	0x89, 0xfc, 0x11, 0xba, 0xc1, 0x00, 0x00, 0x80, 0x01, 0x4e, 0x78,
	0xf3, 0xe8, 0x8a, 0x61, 0xc9, 0x20, 0x00, 0x00, 0x80, 0x06, 0x17,
	0x1f, 0xf4, 0xad, 0xf2, 0xc5, 0x40, 0x00, 0x21, 0xc2, 0xa8, 0x01,
	0xa7, 0xa1, 0x0c, 0x00, 0x20, 0x11, 0x15, 0x80, 0x58, 0x20, 0xa5,
	0xa1, 0x0c, 0x04, 0x00, 0x11, 0xba, 0xb1, 0xa5, 0xa1, 0x0c, 0x00,
	0x80, 0x11, 0xbb, 0xf1, 0xa5, 0xa1, 0x0c, 0x00, 0x08, 0x11, 0xbc,
	0x31, 0x1f, 0x1f, 0xf9, 0x1c, 0x00, 0x00, 0x10, 0x01, 0x00, 0x00,
	0x10, 0x08, 0xf3, 0x80, 0x04, 0x89, 0xb6, 0x11, 0x0f, 0x30, 0x00,
	0x06, 0xa5, 0xa7, 0xf2, 0x87, 0x08, 0x6d, 0x30, 0x66, 0x00, 0x00,
	0x0f, 0xf1, 0x0c, 0x00, 0x02, 0x77, 0xac, 0x51, 0x1c, 0x83, 0x80,
	0xe0, 0x1f, 0x1f, 0xf3, 0x58, 0x1e, 0x1f, 0xff, 0xbc, 0x1f, 0x1f,
	0xf7, 0xda, 0x40, 0x00, 0x21, 0xe6, 0x1f, 0x1f, 0xfd, 0x40, 0x40,
	0x00, 0x21, 0xe2, 0xf3, 0xc0, 0x04, 0x89, 0xf0, 0x11, 0xbc, 0x31,
	0x1f, 0x1f, 0xf6, 0x44, 0x00, 0x00, 0x10, 0x01, 0x00, 0x00, 0x10,
	0x07, 0xf3, 0x80, 0x04, 0x89, 0xb4, 0x11, 0x0f, 0x30, 0x00, 0x06,
	0xf2, 0x86, 0x08, 0x6d, 0x30, 0x66, 0x00, 0x00, 0x0f, 0xf1, 0x16,
	0x1f, 0xff, 0x96, 0x40, 0x00, 0x2c, 0x51, 0xa8, 0x01, 0x0c, 0x02,
	0x00, 0x16, 0xba, 0xf6, 0x0c, 0x00, 0x10, 0x16, 0x15, 0x80, 0x44,
	0xc0, 0x0c, 0x00, 0x40, 0x16, 0xbf, 0xa6, 0x0c, 0x00, 0x04, 0x11,
	0xbc, 0x51, 0x40, 0x00, 0x20, 0x00, 0x1f, 0x1f, 0xfb, 0x64, 0x00,
	0x00, 0x10, 0x01, 0x00, 0x00, 0x10, 0x07, 0xf3, 0x80, 0x04, 0x89,
	0xb3, 0x11, 0x0f, 0x30, 0x00, 0x06, 0xf2, 0x86, 0x08, 0x6d, 0x30,
	0x66, 0x00, 0x00, 0x0f, 0xf1, 0x16, 0x1f, 0xff, 0x68, 0x40, 0x00,
	0x2c, 0x51, 0x1f, 0x1f, 0xf8, 0x30, 0x40, 0x00, 0x21, 0xec, 0x1f,
	0x1f, 0xfa, 0xa2, 0x40, 0x00, 0x21, 0xe8, 0xa5, 0xf1, 0xa8, 0x01,
	0x04, 0x89, 0xfd, 0x11, 0xbe, 0x41, 0xa0, 0x00, 0x1f, 0x1f, 0xfb,
	0x42, 0xa5, 0xf1, 0xa8, 0x01, 0x04, 0x89, 0xf2, 0x11, 0xba, 0x81,
	0xa5, 0xd1, 0x49, 0x8b, 0x20, 0x00, 0xa8, 0x01, 0x04, 0x89, 0x92,
	0x11, 0xac, 0x51, 0xa5, 0xd1, 0x93, 0x18, 0xa8, 0x01, 0xc9, 0xd8,
	0xb4, 0x71, 0xa5, 0xf1, 0xa8, 0x01, 0x04, 0x89, 0xf1, 0x16, 0x93,
	0x81, 0xbe, 0xe6, 0x0f, 0x30, 0x00, 0x01, 0xa0, 0x00, 0x17, 0x1f,
	0xf2, 0x26, 0x0d, 0x63, 0xcc, 0x13, 0xa8, 0x71, 0x04, 0x89, 0x94,
	0x16, 0x49, 0xc0, 0xa0, 0x00, 0xb4, 0x06, 0xa8, 0x76, 0xc9, 0xe5,
	0xb6, 0x06, 0xa5, 0xf1, 0xa8, 0x01, 0x04, 0x89, 0xfe, 0x11, 0xbe,
	0x31, 0x1f, 0x1f, 0xf7, 0xf4, 0xa5, 0xf1, 0xa8, 0x01, 0x0c, 0x00,
	0x02, 0x11, 0xba, 0x61, 0x0f, 0x50, 0x30, 0x01, 0xa8, 0x06, 0xc9,
	0x05, 0xb6, 0x06, 0xa5, 0xf1, 0xa8, 0x01, 0xa5, 0xf1, 0xa8, 0x01,
	0x04, 0x89, 0xff, 0x11, 0xbe, 0x41, 0xa0, 0x00, 0x1f, 0x1f, 0xfa,
	0x56, 0x17, 0x1f, 0xf5, 0x7e, 0x00, 0x00, 0x80, 0x03, 0x0f, 0x01,
	0x94, 0x07, 0x00, 0x00, 0x10, 0x01, 0x00, 0x01, 0x00, 0x46, 0x07,
	0x00, 0x64, 0x71, 0x00, 0x00, 0x10, 0x07, 0xa5, 0xb1, 0x06, 0xf2,
	0xd4, 0x71, 0x06, 0xf0, 0x30, 0x61, 0x00, 0x00, 0x10, 0x06, 0xf3,
	0xad, 0x04, 0x89, 0xb3, 0x66, 0xf2, 0xae, 0x00, 0x00, 0x0f, 0xf6,
	0xac, 0x06, 0x00, 0x00, 0x10, 0x06, 0xf3, 0xad, 0x04, 0x89, 0xb6,
	0x66, 0xf2, 0xae, 0x00, 0x00, 0x0f, 0xf6, 0xac, 0x06, 0x00, 0x00,
	0x10, 0x06, 0xf3, 0xad, 0x04, 0x89, 0xb5, 0x66, 0xf2, 0xae, 0x00,
	0x00, 0x0f, 0xf6, 0x06, 0xf8, 0x00, 0x61, 0x06, 0x4b, 0x50, 0x61,
	0x04, 0x89, 0x87, 0x67, 0x08, 0xff, 0x08, 0x16, 0x06, 0x7b, 0x50,
	0x71, 0x06, 0x4f, 0x08, 0x71, 0xc9, 0x0e, 0x06, 0x7f, 0x08, 0x71,
	0xa8, 0x51, 0x20, 0x20, 0x42, 0x11, 0x15, 0x83, 0xfa, 0x20, 0xa5,
	0xf1, 0xa8, 0x01, 0x0c, 0x02, 0x00, 0x11, 0x1c, 0x80, 0xca, 0x20,
	0x0f, 0x51, 0x00, 0x01, 0x0d, 0xb0, 0x3c, 0x11, 0xa8, 0x01, 0x0c,
	0x04, 0x81, 0x11, 0xba, 0x81, 0x0f, 0x51, 0x00, 0x06, 0x00, 0x0b,
	0x03, 0xc1, 0x44, 0x30, 0xa0, 0x00, 0xac, 0x00, 0x0f, 0x51, 0x00,
	0x01, 0x0d, 0xb1, 0x3c, 0x11, 0xa8, 0x01, 0x0c, 0x04, 0x81, 0x11,
	0xba, 0x71, 0x0f, 0x51, 0x00, 0x06, 0x00, 0x0b, 0x13, 0xc1, 0x88,
	0x61, 0xac, 0x00, 0x0f, 0x51, 0x00, 0x01, 0x0d, 0xb2, 0x3c, 0x11,
	0xa8, 0x01, 0x0c, 0x04, 0x81, 0x11, 0xba, 0x71, 0x0f, 0x51, 0x00,
	0x06, 0x00, 0x0b, 0x23, 0xc1, 0x88, 0x61, 0xac, 0x00, 0x0f, 0x51,
	0x00, 0x01, 0x0d, 0xb3, 0x3c, 0x11, 0xa8, 0x01, 0x0c, 0x04, 0x81,
	0x11, 0xba, 0x71, 0x0f, 0x51, 0x00, 0x06, 0x00, 0x0b, 0x33, 0xc1,
	0x88, 0x61, 0xac, 0x00, 0x0f, 0x51, 0x27, 0x01, 0x0d, 0x80, 0x3c,
	0x11, 0xa8, 0x01, 0x0c, 0x04, 0x81, 0x11, 0xba, 0x71, 0x0f, 0x51,
	0x27, 0x06, 0x00, 0x08, 0x03, 0xc1, 0x88, 0x61, 0xac, 0x00, 0x0f,
	0x51, 0x27, 0x01, 0x0d, 0x81, 0x3c, 0x11, 0xa8, 0x01, 0x0c, 0x04,
	0x81, 0x11, 0xba, 0x71, 0x0f, 0x51, 0x27, 0x06, 0x00, 0x08, 0x13,
	0xc1, 0x88, 0x61, 0xac, 0x00, 0x0f, 0x51, 0x27, 0x01, 0x0d, 0x82,
	0x3c, 0x11, 0xa8, 0x01, 0x0c, 0x04, 0x81, 0x11, 0xba, 0x71, 0x0f,
	0x51, 0x27, 0x06, 0x00, 0x08, 0x23, 0xc1, 0x88, 0x61, 0xac, 0x00,
	0xa5, 0x9f, 0x16, 0x1f, 0xf0, 0xd7, 0x97, 0x9e, 0xbc, 0x43, 0x1d,
	0x80, 0x12, 0x61, 0xa0, 0x00, 0x00, 0x00, 0x80, 0x01, 0x0f, 0x02,
	0x00, 0x06, 0x40, 0x00, 0x72, 0x68, 0x00, 0x03, 0x8a, 0x01, 0xa8,
	0x01, 0x0c, 0x04, 0x00, 0x11, 0xbe, 0x31, 0x40, 0x00, 0x20, 0x3f,
	0x1d, 0x80, 0x08, 0x66, 0x40, 0x00, 0x20, 0x3f, 0x1d, 0x80, 0x08,
	0x67, 0x40, 0x00, 0x20, 0x3f, 0xa0, 0x2f, 0x00, 0x00, 0x80, 0x01,
	0xf2, 0x80, 0x0f, 0x30, 0x00, 0x01, 0x0d, 0x66, 0x28, 0x11, 0xa8,
	0x01, 0xbe, 0x31, 0x4c, 0x08, 0xa0, 0x3f, 0x49, 0x80, 0xa0, 0x3f,
	0x92, 0x01, 0xa7, 0xff, 0x1f, 0x1f, 0xff, 0xf4, 0xbb, 0x41, 0x0f,
	0x30, 0x00, 0x03, 0x0f, 0x55, 0x55, 0x01, 0x0d, 0x55, 0x55, 0x18,
	0x0f, 0x55, 0xff, 0x01, 0x0d, 0xff, 0xff, 0x17, 0x0f, 0xcc, 0xcc,
	0x01, 0x08, 0x64, 0x84, 0x32, 0x0d, 0x64, 0x90, 0x36, 0xa1, 0x0b,
	0x0d, 0xcc, 0xcc, 0x11, 0x08, 0x64, 0x84, 0x32, 0x0d, 0x64, 0x90,
	0x36, 0x4f, 0xfb, 0xf0, 0x01, 0x4f, 0xfc, 0x20, 0x00, 0xb4, 0x98,
	0xb4, 0x98, 0xac, 0x17, 0x17, 0x1f, 0xff, 0xd3, 0xac, 0x51, 0xba,
	0xa1, 0x08, 0x64, 0x6c, 0x31, 0x00, 0x00, 0xa5, 0x56, 0xac, 0x06,
	0xa5, 0xff, 0xa0, 0x2f, 0x97, 0xfe, 0x80, 0x00, 0x08, 0x64, 0x6c,
	0x31, 0x00, 0x00, 0x0f, 0xf6, 0xac, 0x06, 0xa5, 0xff, 0xa0, 0x2f,
	0x97, 0xfe, 0x80, 0x00, 0x80, 0x00, 0x00, 0x00, 0x80, 0x09, 0x49,
	0x00, 0xa0, 0x00, 0x0f, 0x30, 0x00, 0x07, 0x0d, 0x64, 0x94, 0x77,
	0x07, 0x00, 0x40, 0x19, 0xa7, 0xff, 0x04, 0x89, 0xfe, 0x1a, 0xa8,
	0x61, 0x17, 0x1f, 0xff, 0x90, 0x20, 0x21, 0x08, 0x13, 0x0f, 0x04,
	0x00, 0x08, 0x0f, 0x10, 0x00, 0x02, 0x0f, 0x08, 0x00, 0x04, 0xb8,
	0xca, 0x0f, 0x20, 0x00, 0x05, 0x07, 0x00, 0x62, 0x89, 0x07, 0x00,
	0x62, 0x29, 0x07, 0x00, 0x61, 0x49, 0xa1, 0x0b, 0x07, 0x00, 0x61,
	0x59, 0x07, 0x00, 0x61, 0x89, 0x07, 0x00, 0x61, 0x29, 0x07, 0x00,
	0x62, 0x49, 0x07, 0x00, 0x62, 0x59, 0xa8, 0x61, 0x0d, 0x1c, 0x00,
	0x11, 0xb6, 0x61, 0xa5, 0xff, 0xa0, 0x2f, 0x97, 0xfe, 0x80, 0x00,
	0x49, 0x00, 0xa0, 0x00, 0x00, 0x03, 0x8a, 0x01, 0xa7, 0xff, 0xa8,
	0x01, 0x0c, 0x00, 0x04, 0x11, 0x14, 0x80, 0x64, 0x20, 0x0f, 0x30,
	0x00, 0x01, 0x00, 0x03, 0x8a, 0x01, 0xa8, 0x01, 0x04, 0x89, 0xf6,
	0x11, 0xb8, 0x51, 0xa5, 0xff, 0xa0, 0x2f, 0x97, 0xfe, 0x80, 0x00,
	0x0f, 0x30, 0x00, 0x01, 0x17, 0x1f, 0xf0, 0x64, 0x0d, 0x64, 0xf4,
	0x13, 0x0f, 0x30, 0x00, 0x01, 0x17, 0x1f, 0xf0, 0x5e, 0x0d, 0x64,
	0xf0, 0x13, 0x0f, 0x30, 0x00, 0x01, 0x17, 0x1f, 0xf3, 0xbc, 0x0d,
	0x63, 0x54, 0x13, 0x0f, 0x30, 0x00, 0x01, 0x17, 0x1f, 0xf3, 0xb6,
	0x0d, 0x63, 0x50, 0x13, 0x0f, 0x30, 0x00, 0x01, 0x0d, 0x68, 0x4c,
	0x11, 0xa8, 0x06, 0x04, 0x89, 0x95, 0x66, 0xb6, 0x06, 0xa5, 0xff,
	0xa0, 0x2f, 0x97, 0xfe, 0x80, 0x00, 0x17, 0x1f, 0xf0, 0x42, 0x0d,
	0x64, 0xfc, 0x13, 0x0f, 0x30, 0x00, 0x01, 0x17, 0x1f, 0xf0, 0x3c,
	0x0d, 0x64, 0xf8, 0x13, 0x0f, 0x30, 0x00, 0x01, 0x17, 0x1f, 0xee,
	0x30, 0x0d, 0x63, 0x4c, 0x13, 0x0f, 0x30, 0x00, 0x01, 0x17, 0x1f,
	0xee, 0x2a, 0x0d, 0x63, 0x48, 0x13, 0x1e, 0x1f, 0xff, 0xbc, 0x49,
	0x00, 0xa0, 0x00, 0x00, 0x03, 0x8a, 0x01, 0xa7, 0xff, 0xa8, 0x01,
	0x04, 0x89, 0xf6, 0x11, 0x14, 0x80, 0x80, 0x20, 0x0f, 0x30, 0x00,
	0x01, 0x00, 0x03, 0x8a, 0x01, 0xa8, 0x01, 0x0c, 0x00, 0x04, 0x11,
	0xb9, 0xb1, 0x0f, 0x30, 0x00, 0x01, 0x00, 0x03, 0x8a, 0x01, 0xa8,
	0x01, 0x04, 0x89, 0xf6, 0x11, 0xba, 0x91, 0x0f, 0x50, 0x94, 0x06,
	0x98, 0x17, 0x0f, 0x00, 0x10, 0x01, 0x44, 0x30, 0xac, 0x57, 0xac,
	0x07, 0xa5, 0xff, 0x0f, 0x30, 0x00, 0x01, 0x97, 0xfe, 0x0d, 0x69,
	0x80, 0x14, 0x16, 0x1f, 0xee, 0xb4, 0x00, 0x00, 0x92, 0x43, 0x0d,
	0x63, 0x48, 0x13, 0x17, 0x1f, 0xf3, 0x88, 0x00, 0x00, 0x05, 0xe4,
	0x0f, 0x30, 0x00, 0x01, 0x0d, 0x63, 0x4c, 0x13, 0x17, 0x1f, 0xf3,
	0x80, 0x00, 0x00, 0x05, 0xe4, 0x0f, 0x30, 0x00, 0x01, 0x17, 0x1f,
	0xf0, 0x06, 0x0d, 0x64, 0xf8, 0x13, 0x0f, 0x30, 0x00, 0x01, 0x17,
	0x1f, 0xf0, 0x00, 0x0d, 0x64, 0xfc, 0x13, 0x40, 0x00, 0x21, 0xce,
	0x0d, 0x63, 0x50, 0x13, 0x17, 0x1f, 0xf3, 0x16, 0x00, 0x00, 0x05,
	0xe4, 0x0f, 0x30, 0x00, 0x01, 0x0d, 0x63, 0x54, 0x13, 0x17, 0x1f,
	0xf3, 0x0e, 0x00, 0x00, 0x05, 0xe4, 0x0f, 0x30, 0x00, 0x01, 0x17,
	0x1f, 0xef, 0xea, 0x0d, 0x64, 0xf0, 0x13, 0x0f, 0x30, 0x00, 0x01,
	0x17, 0x1f, 0xef, 0xe4, 0x0d, 0x64, 0xf4, 0x13, 0x0f, 0x30, 0x00,
	0x01, 0x0d, 0x68, 0x4c, 0x11, 0xa8, 0x06, 0x04, 0x89, 0x96, 0x66,
	0x16, 0x1f, 0xff, 0xa3, 0xb6, 0x06, 0x92, 0x05, 0x0f, 0x30, 0x00,
	0x01, 0x0d, 0x64, 0x3c, 0x11, 0xa7, 0xbf, 0xa8, 0x06, 0x64, 0x82,
	0xa0, 0x00, 0x17, 0x1f, 0xee, 0x95, 0xb6, 0x06, 0x1f, 0x1f, 0xff,
	0x02, 0x1f, 0x1f, 0xfe, 0xc6, 0x00, 0x03, 0x8a, 0x01, 0xa7, 0xf1,
	0x00, 0x03, 0x86, 0xc1, 0xa7, 0xe1, 0x0f, 0x30, 0x00, 0x01, 0x0d,
	0x61, 0x30, 0x11, 0x40, 0x00, 0x27, 0xd1, 0x00, 0x00, 0x80, 0x01,
	0x00, 0x00, 0x20, 0x06, 0x00, 0x00, 0x10, 0x07, 0x07, 0x00, 0x64,
	0x61, 0x0f, 0x01, 0x94, 0x08, 0x0f, 0x0b, 0x16, 0x01, 0x0f, 0x30,
	0x00, 0x06, 0x0d, 0x00, 0x0c, 0x11, 0x08, 0x60, 0x44, 0x66, 0x07,
	0x00, 0x65, 0x87, 0x40, 0x00, 0x2c, 0x51, 0xa5, 0xd6, 0xa8, 0x56,
	0x15, 0x83, 0xfc, 0xc0, 0x0f, 0x30, 0x00, 0x06, 0x08, 0x60, 0x48,
	0x66, 0x0f, 0x01, 0x94, 0x07, 0xac, 0x51, 0x00, 0x00, 0x10, 0x01,
	0x07, 0x00, 0x64, 0x71, 0x06, 0x45, 0xb8, 0x16, 0xa5, 0xf7, 0xac,
	0x61, 0x06, 0x45, 0xc0, 0x16, 0xa5, 0xe6, 0xb4, 0x51, 0xa7, 0xc6,
	0xa8, 0x66, 0x0f, 0xf8, 0x00, 0x01, 0x45, 0xb0, 0xa0, 0x00, 0x17,
	0x1f, 0xed, 0x21, 0xac, 0x61, 0xa5, 0xf1, 0xa8, 0x01, 0x0c, 0x04,
	0x00, 0x11, 0xbe, 0x41, 0xa0, 0x00, 0x1f, 0x1f, 0xfb, 0xf6, 0xa5,
	0xf1, 0xa8, 0x01, 0x0c, 0x04, 0x00, 0x11, 0xb8, 0x81, 0xa5, 0xf1,
	0xa8, 0x01, 0x0c, 0x00, 0x20, 0x11, 0xbe, 0x31, 0x1f, 0x1f, 0xed,
	0x7a, 0xa5, 0xc1, 0xa8, 0x01, 0x0c, 0x00, 0x40, 0x11, 0x14, 0x83,
	0x64, 0x20, 0x0f, 0x80, 0x00, 0x06, 0x00, 0x00, 0x80, 0x07, 0x49,
	0x80, 0xa5, 0xbf, 0x07, 0x00, 0x67, 0x67, 0x4b, 0xdf, 0x20, 0x3f,
	0x00, 0x01, 0x00, 0x01, 0x01, 0x02, 0x00, 0x01, 0x01, 0x02, 0x01,
	0x02, 0x02, 0x04, 0x00, 0x01, 0x02, 0x04, 0x01, 0x02, 0x02, 0x04,
	0x02, 0x04, 0x03, 0x08, 0x00, 0x01, 0x03, 0x08, 0x01, 0x02, 0x03,
	0x08, 0x02, 0x04, 0x04, 0x10, 0x00, 0x01, 0x04, 0x10, 0x01, 0x02,
	0x04, 0x10, 0x02, 0x04, 0x04, 0x10, 0x03, 0x08, 0x05, 0x20, 0x00,
	0x01, 0x05, 0x20, 0x01, 0x02, 0x05, 0x20, 0x02, 0x04, 0x05, 0x20,
	0x03, 0x08, 0x06, 0x40, 0x00, 0x01, 0x06, 0x40, 0x01, 0x02, 0x06,
	0x40, 0x02, 0x04, 0x06, 0x40, 0x03, 0x08, 0xc8, 0x09, 0x00, 0x00,
	0xdd, 0x09, 0x00, 0x00, 0x00, 0x00, 0x00, 0x10, 0x00, 0x38, 0x00,
	0x10, 0x70, 0x63, 0x6d, 0x5f, 0x73, 0x75, 0x73, 0x70, 0x65, 0x6e,
	0x64, 0x5f, 0x76, 0x31, 0x2e, 0x30, 0x5f, 0x32, 0x30, 0x32, 0x31,
	0x30, 0x35, 0x31, 0x39, 0x20, 0x20, 0x20,
	0x00, 0x00, 0x00, 0x00	/* 1 byte padding for null-terminted string
				 * and 3 bytes padding for 4-byte alignment
				 */
};

static const struct pwr_ctrl spm_init_ctrl = {
	.pcm_flags = SPM_FLAG_DISABLE_VCORE_DVS | SPM_FLAG_DISABLE_VCORE_DFS |
		     SPM_FLAG_RUN_COMMON_SCENARIO,
	/* SPM_AP_STANDBY_CON */
	/* [0] */
	.reg_wfi_op = 0,
	/* [1] */
	.reg_wfi_type = 0,
	/* [2] */
	.reg_mp0_cputop_idle_mask = 0,
	/* [3] */
	.reg_mp1_cputop_idle_mask = 0,
	/* [4] */
	.reg_mcusys_idle_mask = 0,
	/* [25] */
	.reg_md_apsrc_1_sel = 0,
	/* [26] */
	.reg_md_apsrc_0_sel = 0,
	/* [29] */
	.reg_conn_apsrc_sel = 0,
	/* SPM_SRC_REQ */
	/* [0] */
	.reg_spm_apsrc_req = 0,
	/* [1] */
	.reg_spm_f26m_req = 0,
	/* [3] */
	.reg_spm_infra_req = 0,
	/* [4] */
	.reg_spm_vrf18_req = 0,
	/* [7] FIXME: default disable HW Auto S1*/
	.reg_spm_ddr_en_req = 1,
	/* [8] */
	.reg_spm_dvfs_req = 0,
	/* [9] */
	.reg_spm_sw_mailbox_req = 0,
	/* [10] */
	.reg_spm_sspm_mailbox_req = 0,
	/* [11] */
	.reg_spm_adsp_mailbox_req = 0,
	/* [12] */
	.reg_spm_scp_mailbox_req = 0,
	/* SPM_SRC_MASK */
	/* [0] */
	.reg_sspm_srcclkena_0_mask_b = 1,
	/* [1] */
	.reg_sspm_infra_req_0_mask_b = 1,
	/* [2] */
	.reg_sspm_apsrc_req_0_mask_b = 1,
	/* [3] */
	.reg_sspm_vrf18_req_0_mask_b = 1,
	/* [4] */
	.reg_sspm_ddr_en_0_mask_b = 1,
	/* [5] */
	.reg_scp_srcclkena_mask_b = 1,
	/* [6] */
	.reg_scp_infra_req_mask_b = 1,
	/* [7] */
	.reg_scp_apsrc_req_mask_b = 1,
	/* [8] */
	.reg_scp_vrf18_req_mask_b = 1,
	/* [9] */
	.reg_scp_ddr_en_mask_b = 1,
	/* [10] */
	.reg_audio_dsp_srcclkena_mask_b = 1,
	/* [11] */
	.reg_audio_dsp_infra_req_mask_b = 1,
	/* [12] */
	.reg_audio_dsp_apsrc_req_mask_b = 1,
	/* [13] */
	.reg_audio_dsp_vrf18_req_mask_b = 1,
	/* [14] */
	.reg_audio_dsp_ddr_en_mask_b = 1,
	/* [15] */
	.reg_apu_srcclkena_mask_b = 1,
	/* [16] */
	.reg_apu_infra_req_mask_b = 1,
	/* [17] */
	.reg_apu_apsrc_req_mask_b = 1,
	/* [18] */
	.reg_apu_vrf18_req_mask_b = 1,
	/* [19] */
	.reg_apu_ddr_en_mask_b = 1,
	/* [20] */
	.reg_cpueb_srcclkena_mask_b = 1,
	/* [21] */
	.reg_cpueb_infra_req_mask_b = 1,
	/* [22] */
	.reg_cpueb_apsrc_req_mask_b = 1,
	/* [23] */
	.reg_cpueb_vrf18_req_mask_b = 1,
	/* [24] */
	.reg_cpueb_ddr_en_mask_b = 1,
	/* [25] */
	.reg_bak_psri_srcclkena_mask_b = 0,
	/* [26] */
	.reg_bak_psri_infra_req_mask_b = 0,
	/* [27] */
	.reg_bak_psri_apsrc_req_mask_b = 0,
	/* [28] */
	.reg_bak_psri_vrf18_req_mask_b = 0,
	/* [29] */
	.reg_bak_psri_ddr_en_mask_b = 0,
	/* SPM_SRC2_MASK */
	/* [0] */
	.reg_msdc0_srcclkena_mask_b = 1,
	/* [1] */
	.reg_msdc0_infra_req_mask_b = 1,
	/* [2] */
	.reg_msdc0_apsrc_req_mask_b = 1,
	/* [3] */
	.reg_msdc0_vrf18_req_mask_b = 1,
	/* [4] */
	.reg_msdc0_ddr_en_mask_b = 1,
	/* [5] */
	.reg_msdc1_srcclkena_mask_b = 1,
	/* [6] */
	.reg_msdc1_infra_req_mask_b = 1,
	/* [7] */
	.reg_msdc1_apsrc_req_mask_b = 1,
	/* [8] */
	.reg_msdc1_vrf18_req_mask_b = 1,
	/* [9] */
	.reg_msdc1_ddr_en_mask_b = 1,
	/* [10] */
	.reg_msdc2_srcclkena_mask_b = 1,
	/* [11] */
	.reg_msdc2_infra_req_mask_b = 1,
	/* [12] */
	.reg_msdc2_apsrc_req_mask_b = 1,
	/* [13] */
	.reg_msdc2_vrf18_req_mask_b = 1,
	/* [14] */
	.reg_msdc2_ddr_en_mask_b = 1,
	/* [15] */
	.reg_ufs_srcclkena_mask_b = 1,
	/* [16] */
	.reg_ufs_infra_req_mask_b = 1,
	/* [17] */
	.reg_ufs_apsrc_req_mask_b = 1,
	/* [18] */
	.reg_ufs_vrf18_req_mask_b = 1,
	/* [19] */
	.reg_ufs_ddr_en_mask_b = 1,
	/* [20] */
	.reg_usb_srcclkena_mask_b = 1,
	/* [21] */
	.reg_usb_infra_req_mask_b = 1,
	/* [22] */
	.reg_usb_apsrc_req_mask_b = 1,
	/* [23] */
	.reg_usb_vrf18_req_mask_b = 1,
	/* [24] */
	.reg_usb_ddr_en_mask_b = 1,
	/* [25] */
	.reg_pextp_p0_srcclkena_mask_b = 1,
	/* [26] */
	.reg_pextp_p0_infra_req_mask_b = 1,
	/* [27] */
	.reg_pextp_p0_apsrc_req_mask_b = 1,
	/* [28] */
	.reg_pextp_p0_vrf18_req_mask_b = 1,
	/* [29] */
	.reg_pextp_p0_ddr_en_mask_b = 1,
	/* SPM_SRC3_MASK */
	/* [0] */
	.reg_pextp_p1_srcclkena_mask_b = 1,
	/* [1] */
	.reg_pextp_p1_infra_req_mask_b = 1,
	/* [2] */
	.reg_pextp_p1_apsrc_req_mask_b = 1,
	/* [3] */
	.reg_pextp_p1_vrf18_req_mask_b = 1,
	/* [4] */
	.reg_pextp_p1_ddr_en_mask_b = 1,
	/* [5] */
	.reg_gce0_infra_req_mask_b = 1,
	/* [6] */
	.reg_gce0_apsrc_req_mask_b = 1,
	/* [7] */
	.reg_gce0_vrf18_req_mask_b = 1,
	/* [8] */
	.reg_gce0_ddr_en_mask_b = 1,
	/* [9] */
	.reg_gce1_infra_req_mask_b = 1,
	/* [10] */
	.reg_gce1_apsrc_req_mask_b = 1,
	/* [11] */
	.reg_gce1_vrf18_req_mask_b = 1,
	/* [12] */
	.reg_gce1_ddr_en_mask_b = 1,
	/* [13] */
	.reg_spm_srcclkena_reserved_mask_b = 1,
	/* [14] */
	.reg_spm_infra_req_reserved_mask_b = 1,
	/* [15] */
	.reg_spm_apsrc_req_reserved_mask_b = 1,
	/* [16] */
	.reg_spm_vrf18_req_reserved_mask_b = 1,
	/* [17] */
	.reg_spm_ddr_en_reserved_mask_b = 1,
	/* [18] */
	.reg_disp0_apsrc_req_mask_b = 1,
	/* [19] */
	.reg_disp0_ddr_en_mask_b = 1,
	/* [20] */
	.reg_disp1_apsrc_req_mask_b = 1,
	/* [21] */
	.reg_disp1_ddr_en_mask_b = 1,
	/* [22] */
	.reg_disp2_apsrc_req_mask_b = 1,
	/* [23] */
	.reg_disp2_ddr_en_mask_b = 1,
	/* [24] */
	.reg_disp3_apsrc_req_mask_b = 1,
	/* [25] */
	.reg_disp3_ddr_en_mask_b = 1,
	/* [26] */
	.reg_infrasys_apsrc_req_mask_b = 0,
	/* [27] */
	.reg_infrasys_ddr_en_mask_b = 1,
	/* [28] */
	.reg_cg_check_srcclkena_mask_b = 1,
	/* [29] */
	.reg_cg_check_apsrc_req_mask_b = 1,
	/* [30] */
	.reg_cg_check_vrf18_req_mask_b = 1,
	/* [31] */
	.reg_cg_check_ddr_en_mask_b = 1,
	/* SPM_SRC4_MASK */
	/* [8:0] */
	.reg_mcusys_merge_apsrc_req_mask_b = 0x17,
	/* [17:9] */
	.reg_mcusys_merge_ddr_en_mask_b = 0x17,
	/* [19:18] */
	.reg_dramc_md32_infra_req_mask_b = 0,
	/* [21:20] */
	.reg_dramc_md32_vrf18_req_mask_b = 0,
	/* [23:22] */
	.reg_dramc_md32_ddr_en_mask_b = 0,
	/* [24] */
	.reg_dvfsrc_event_trigger_mask_b = 1,
	/* SPM_WAKEUP_EVENT_MASK2 */
	/* [3:0] */
	.reg_sc_sw2spm_wakeup_mask_b = 0,
	/* [4] */
	.reg_sc_adsp2spm_wakeup_mask_b = 0,
	/* [8:5] */
	.reg_sc_sspm2spm_wakeup_mask_b = 0,
	/* [9] */
	.reg_sc_scp2spm_wakeup_mask_b = 0,
	/* [10] */
	.reg_csyspwrup_ack_mask = 0,
	/* [11] */
	.reg_csyspwrup_req_mask = 1,
	/* SPM_WAKEUP_EVENT_MASK */
	/* [31:0] */
	.reg_wakeup_event_mask = 0xC1382213,
	/* SPM_WAKEUP_EVENT_EXT_MASK */
	/* [31:0] */
	.reg_ext_wakeup_event_mask = 0xFFFFFFFF,
};


static void spm_code_swapping(void)
{
	uint32_t con1;
	/* int retry = 0, timeout = 5000; */

	con1 = mmio_read_32(SPM_WAKEUP_EVENT_MASK);

	mmio_write_32(SPM_WAKEUP_EVENT_MASK, (con1 & ~(0x1)));
	mmio_write_32(SPM_CPU_WAKEUP_EVENT, 1);
	mmio_write_32(SPM_CPU_WAKEUP_EVENT, 0);
	mmio_write_32(SPM_WAKEUP_EVENT_MASK, con1);
}

static void set_top_reg_for_spm(void)
{
	/*  CLK_SCP_CFG_0 (TOPCKGEN_BASE + 0x0264)
	 *      Set clock path for SPM
	 *      0       sc_hd_faxi_ck_26m_ck_off_en
	 *      1       sc_hd_faxi_ck_26m_ck_sel_en
	 *      2       sc_hf_fscp_ck_26m_ck_off_en
	 *      3       sc_hf_fscp_ck_26m_ck_sel_en
	 *      4       sc_hd_fbus_aximem_ck_26m_ck_off_en
	 *      5       sc_hd_fbus_aximem_ck_26m_ck_sel_en
	 *      6       sc_hf_fadsp_ck_off_en
	 *      7       sc_hf_fadsp_ck_slowsel_en
	 *      8       sc_hf_faudio_local_bus_ck_off_en
	 *      9       sc_hf_faudio_local_bus_ck_slowsel_en
	 *      10      sc_root_26m_ck_off_en
	 */
	mmio_write_32(CLK_SCP_CFG_0, mmio_read_32(CLK_SCP_CFG_0) | 0x7FF);
	INFO("CLK_SCP_CFG_0(0x%x) = 0x%x\n", CLK_SCP_CFG_0,
	     mmio_read_32(CLK_SCP_CFG_0));
}

static void spm_register_init(void)
{
	/* enable register control */
	mmio_write_32(POWERON_CONFIG_EN, SPM_REGWR_CFG_KEY | BCLK_CG_EN_LSB);

	/* init power control register, dram will set this register */
	mmio_write_32(SPM_POWER_ON_VAL1, POWER_ON_VAL1_DEF);
	mmio_write_32(PCM_PWR_IO_EN, 0);

	/* reset PCM */
	mmio_write_32(PCM_CON0,
		      SPM_REGWR_CFG_KEY | PCM_CK_EN_LSB | PCM_SW_RESET_LSB);
	mmio_write_32(PCM_CON0, SPM_REGWR_CFG_KEY | PCM_CK_EN_LSB);
	mmio_write_32(PCM_CON1, SPM_REGWR_CFG_KEY | REG_EVENT_LOCK_EN_LSB |
		      REG_SPM_SRAM_ISOINT_B_LSB | RG_AHBMIF_APBEN_LSB |
		      REG_MD32_APB_INTERNAL_EN_LSB);

	/* Initial SPM CLK control register */
	mmio_setbits_32(SPM_CLK_CON, REG_SYSCLK1_SRC_MD2_SRCCLKENA_LSB);

	/* clean wakeup event raw status */
	mmio_write_32(SPM_WAKEUP_EVENT_MASK, SPM_WAKEUP_EVENT_MASK_DEF);

	/* clean ISR status */
	mmio_write_32(SPM_IRQ_MASK, ISRM_ALL);
	mmio_write_32(SPM_IRQ_STA, ISRC_ALL);
	mmio_write_32(SPM_SWINT_CLR, PCM_SW_INT_ALL);

	/* init r7 with POWER_ON_VAL1 */
	mmio_write_32(PCM_REG_DATA_INI, mmio_read_32(SPM_POWER_ON_VAL1));
	mmio_write_32(PCM_PWR_IO_EN, PCM_RF_SYNC_R7);
	mmio_write_32(PCM_PWR_IO_EN, 0);

	/* Configure ARMPLL Control Mode for MCDI */
	mmio_write_32(ARMPLL_CLK_SEL, ARMPLL_CLK_SEL_DEF);

	/* Init for SPM Resource ACK */
	mmio_write_32(SPM_RESOURCE_ACK_CON0, SPM_RESOURCE_ACK_CON0_DEF);
	mmio_write_32(SPM_RESOURCE_ACK_CON1, SPM_RESOURCE_ACK_CON1_DEF);
	mmio_write_32(SPM_RESOURCE_ACK_CON2, SPM_RESOURCE_ACK_CON2_DEF);
	mmio_write_32(SPM_RESOURCE_ACK_CON3, SPM_RESOURCE_ACK_CON3_DEF);

	/* Init VCORE DVFS Status */
	mmio_clrbits_32(SPM_DVFS_MISC, SPM_DVFS_FORCE_ENABLE_LSB);
	mmio_setbits_32(SPM_DVFS_MISC, SPM_DVFSRC_ENABLE_LSB);
	mmio_write_32(SPM_DVFS_LEVEL, 0x00000001);
	mmio_write_32(SPM_DVS_DFS_LEVEL, 0x00010001);
}

static void spm_parse_firmware(struct mtk_mcu *mcu)
{
	size_t file_size, copy_size;
	int offset;
	uint16_t firmware_size;
	struct dyna_load_pcm *pcm = (struct dyna_load_pcm *)mcu->priv;

	file_size = mcu->run_size;

	/*
	 * spmfw layout:
	 *   uint16_t firmware_size
	 *   uint32_t binary[firmware_size]
	 *   struct pcm_desc descriptor
	 *   char *version
	 */

	/* Firmware size */
	offset = 0;
	copy_size = sizeof(firmware_size);
	memcpy(&firmware_size, mcu->load_buffer + offset, copy_size);
	NOTICE("SPM: binary array size = 0x%x\n", firmware_size);

	/* Binary */
	offset = SPMFW_HEADER_SIZE;	/* binary start offset */
	copy_size = firmware_size * sizeof(uint32_t);
	assert(offset < file_size);
	pcm->buf = (uint8_t *) (mcu->load_buffer + offset);

	/* Descriptor */
	offset += copy_size;
	assert(offset < file_size);
	copy_size = sizeof(pcm->desc);
	memcpy(&pcm->desc, mcu->load_buffer + offset, copy_size);

	/* Firmware size and total words need to be the same */
	assert(firmware_size == pcm->desc.total_words);

	/* Version */
	offset += copy_size;
	assert(offset < file_size);

	NOTICE("SPM: spmfw version: %s\n", (char *)mcu->load_buffer + offset);
}

static void __spm_reset_and_init_pcm(void)
{
	unsigned char first_load_fw = true;

	/* check the SPM FW is run or not */
	if (mmio_read_32(MD32PCM_CFGREG_SW_RSTN) & MD32PCM_CFGREG_SW_RSTN_RUN)
		first_load_fw = false;

	if (!first_load_fw) {
		/* SPM code swapping */
		spm_code_swapping();

		/* Backup PCM r0 -> SPM_POWER_ON_VAL0 before `reset PCM` */
		mmio_write_32(SPM_POWER_ON_VAL0, mmio_read_32(PCM_REG0_DATA));
	}

	/* disable r0 and r7 to control power */
	mmio_write_32(PCM_PWR_IO_EN, 0);

	/* disable pcm timer after leaving FW */
	mmio_clrsetbits_32(PCM_CON1, RG_PCM_TIMER_EN_LSB, SPM_REGWR_CFG_KEY);

	/* reset PCM */
	mmio_write_32(PCM_CON0,
		      SPM_REGWR_CFG_KEY | PCM_CK_EN_LSB | PCM_SW_RESET_LSB);
	mmio_write_32(PCM_CON0, SPM_REGWR_CFG_KEY | PCM_CK_EN_LSB);

	mmio_clrsetbits_32(PCM_CON1, ~RG_PCM_WDT_WAKE_LSB,
		      SPM_REGWR_CFG_KEY | REG_EVENT_LOCK_EN_LSB |
		      REG_SPM_SRAM_ISOINT_B_LSB | RG_AHBMIF_APBEN_LSB |
		      REG_MD32_APB_INTERNAL_EN_LSB);
}

static void __spm_kick_im_to_fetch(const struct dyna_load_pcm *pcm)
{
	uintptr_t ptr;
	uint32_t dmem_words;
	uint32_t pmem_words;
	uint32_t total_words;
	uint32_t pmem_start;
	uint32_t dmem_start;

	ptr = (uintptr_t) pcm->buf + SPM_SYSTEM_BASE_OFFSET;
	pmem_words = pcm->desc.pmem_words;
	total_words = pcm->desc.total_words;
	dmem_words = total_words - pmem_words;
	pmem_start = pcm->desc.pmem_start;
	dmem_start = pcm->desc.dmem_start;

	NOTICE("%s: ptr = 0x%lx, pmem/dmem words = 0x%x/0x%x\n",
	       __func__, (long)ptr, pmem_words, dmem_words);

	/* DMA needs 16-byte aligned source data. */
	assert(ptr % 16 == 0);

	if (mmio_read_32(MD32PCM_DMA0_SRC) != ptr
	    || mmio_read_32(MD32PCM_DMA0_DST) != pmem_start
	    || mmio_read_32(MD32PCM_DMA0_WPPT) != pmem_words
	    || mmio_read_32(MD32PCM_DMA0_WPTO) != dmem_start
	    || mmio_read_32(MD32PCM_DMA0_COUNT) != total_words
	    || mmio_read_32(MD32PCM_DMA0_CON) != MD32PCM_DMA0_CON_VAL) {
		mmio_write_32(MD32PCM_DMA0_SRC, ptr);
		mmio_write_32(MD32PCM_DMA0_DST, pmem_start);
		mmio_write_32(MD32PCM_DMA0_WPPT, pmem_words);
		mmio_write_32(MD32PCM_DMA0_WPTO, dmem_start);
		mmio_write_32(MD32PCM_DMA0_COUNT, total_words);
		mmio_write_32(MD32PCM_DMA0_CON, MD32PCM_DMA0_CON_VAL);
		mmio_write_32(MD32PCM_DMA0_START, MD32PCM_DMA0_START_VAL);
	}

	/* kick IM to fetch (only toggle IM_KICK) */
	mmio_setbits_32(PCM_CON0, SPM_REGWR_CFG_KEY | PCM_CK_EN_LSB);
}

static void __spm_init_pcm_register(void)
{
	/* init r0 with POWER_ON_VAL0 */
	mmio_write_32(PCM_REG_DATA_INI, mmio_read_32(SPM_POWER_ON_VAL0));
	mmio_write_32(PCM_PWR_IO_EN, PCM_RF_SYNC_R0);
	mmio_write_32(PCM_PWR_IO_EN, 0);

	/* init r7 with POWER_ON_VAL1 */
	mmio_write_32(PCM_REG_DATA_INI, mmio_read_32(SPM_POWER_ON_VAL1));
	mmio_write_32(PCM_PWR_IO_EN, PCM_RF_SYNC_R7);
	mmio_write_32(PCM_PWR_IO_EN, 0);
}

void __spm_init_set_wakeup_event(const struct pwr_ctrl *pwrctrl)
{
	uint32_t val, mask;

	/* toggle event counter clear */
	mmio_setbits_32(PCM_CON1,
			SPM_REGWR_CFG_KEY | SPM_EVENT_COUNTER_CLR_LSB);

	/* toggle for reset SYS TIMER start point */
	mmio_setbits_32(SYS_TIMER_CON, SYS_TIMER_START_EN_LSB);

	if (pwrctrl->timer_val_cust == 0U)
		val = pwrctrl->timer_val ? pwrctrl->timer_val : PCM_TIMER_MAX;
	else
		val = pwrctrl->timer_val_cust;

	mmio_write_32(PCM_TIMER_VAL, val);

	/* Disable pcm timer */
	mmio_clrsetbits_32(PCM_CON1, RG_PCM_TIMER_EN_LSB, SPM_REGWR_CFG_KEY);

	/* unmask AP wakeup source */
	if (pwrctrl->wake_src_cust == 0U)
		mask = pwrctrl->wake_src;
	else
		mask = pwrctrl->wake_src_cust;

	mmio_write_32(SPM_WAKEUP_EVENT_MASK, ~mask);

	/* unmask SPM ISR (keep TWAM setting) */
	mmio_setbits_32(SPM_IRQ_MASK, ISRS_TWAM);
	mmio_setbits_32(SPM_IRQ_MASK, 0x3FF << 8);

	/* toggle event counter clear */
	mmio_clrsetbits_32(PCM_CON1, SPM_EVENT_COUNTER_CLR_LSB,
			   SPM_REGWR_CFG_KEY);

	/* toggle for reset SYS TIMER start point */
	mmio_clrbits_32(SYS_TIMER_CON, SYS_TIMER_START_EN_LSB);
}

void __spm_kick_pcm_to_run(struct pwr_ctrl *pwrctrl)
{
	/* Waiting for loading SPMFW done */
	while (mmio_read_32(MD32PCM_DMA0_RLCT) != 0x0)
		;

	/* FIXME: init register to match PCM expectation */
	mmio_write_32(SPM_BUS_PROTECT_MASK_B, SPM_BUS_PROTECT_MASK_B_DEF);
	mmio_write_32(SPM_BUS_PROTECT2_MASK_B, SPM_BUS_PROTECT2_MASK_B_DEF);
	mmio_write_32(PCM_REG_DATA_INI, 0);

	__spm_set_pcm_flags(pwrctrl);

	/* kick PCM to run (only toggle PCM_KICK) */
	mmio_setbits_32(PCM_CON0, SPM_REGWR_CFG_KEY | PCM_CK_EN_LSB);

	/* reset md32pcm */
	mmio_setbits_32(MD32PCM_CFGREG_SW_RSTN, MD32PCM_CFGREG_SW_RSTN_RUN);

	/* Waiting for SPM init done and entering WFI */
	udelay(SPM_INIT_DONE_US);
}

static void reset_spm(struct mtk_mcu *mcu)
{
	struct dyna_load_pcm *pcm = (struct dyna_load_pcm *)mcu->priv;

	spm_parse_firmware(mcu);
	__spm_reset_and_init_pcm();
	__spm_kick_im_to_fetch(pcm);
	__spm_init_pcm_register();
	__spm_init_set_wakeup_event(&spm_init_ctrl);
	__spm_kick_pcm_to_run(&spm_init_ctrl);
}

static struct mtk_mcu spm = {
	.firmware_name = CONFIG_SPM_FIRMWARE,
	.reset = reset_spm,
	.load_buffer = spm_binary,
	.buffer_size = sizeof(spm_binary),
	.run_size = 10160,
};

static void spm_set_sysclk_settle(void)
{
	uint32_t settle;

	mmio_write_32(SPM_CLK_SETTLE, SPM_SYSCLK_SETTLE);
	settle = mmio_read_32(SPM_CLK_SETTLE);

	INFO("md_settle = %u, settle = %u\n", SPM_SYSCLK_SETTLE, settle);
}

void spm_boot_init(void)
{
	NOTICE("MT8195 %s\n", __func__);
	/* switch ck_off/axi_26m control to SPM */
	mmio_setbits_32(CLK_SCP_CFG_0, SPM_CK_CONTROL_EN);

	plat_spm_lock_init();

	mt_spm_pmic_wrap_set_phase(PMIC_WRAP_PHASE_ALLINONE);
	mt_lp_rm_register(&plat_mt8195_rm);
	mt_spm_idle_generic_init();
	mt_spm_suspend_init();
}

void spm_init(void)
{
	struct dyna_load_pcm pcm;

	spm_register_init();
	__spm_set_power_control(&spm_init_ctrl);
	spm_set_sysclk_settle();

	spm.priv = (void *)&pcm;
	if (mtk_init_mcu(&spm)) {
		ERROR("SPM: %s: failed in mtk_init_mcu\n", __func__);
	}

	INFO("SPM: %s done, spm pc = 0x%x\n", __func__, mmio_read_32(0x10006194));
}
